<%-- Reciprocal Net project
  -- /admin/index.jsp
  --
  -- 22-Jul-2002: jobollin wrote first draft
  -- 22-Jul-2002: hclin modified first draft
  -- 21-Nov-2002: ekoperda fixed bug #610 by disabling all siteadmin-only links
  --%>

<%@page session="true" isThreadSafe="true"
        info="Site / Lab Administration"
        import="org.recipnet.site.wrapper.HtmlHelper" %>
<%@include file="/WEB-INF/common.inc" %>
<%  // authController, pageHelper, and replController now available
    boolean siteAdminFlag = false;

    /*
     * This page is accessible only to site and lab administrators.
     * Request unauthenticated users to authenticate:
     */
    if (!authController.checkUserAuthenticationStatus()) {
        // The user has not authenticated
        request.setAttribute("reason", authController.AUTHENTICATION_REQUIRED);
        %><jsp:forward page="/login.jsp" /><%
    } else if (authController.isSiteAdmin()) {
        // the user has site admin privileges.
        // TODO: right now we always set the siteAdminFlag to false because
        //       none of the links on this page that depend on the
        //       siteAdminFlag work yet.  Set siteAdminFlag to true once the
        //       targets of these links are functional.
        siteAdminFlag = false;
    } else if (!authController.isLabAdmin()) {
        // The user's authorization is insufficient
        request.setAttribute("reason", authController.INSUFFICIENT_ACCESS); %>
        <jsp:forward page="/login.jsp" /> <%
    }
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Reciprocal Net - <%=getServletInfo() %></title>
    <link href="../recipnet.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <jsp:include page="/header.jsp">
      <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
    <br/>
    <div>
      <%= HtmlHelper.menuItem(HtmlHelper.PAGEMENU, "Manage Labs",
                              "managelabs.jsp") %><br /><br />
      <%= HtmlHelper.menuItem(HtmlHelper.PAGEMENU, "Configure Site",
                              "siteconfig.jsp", siteAdminFlag) %><br /><br /> 
      <%= HtmlHelper.menuItem(HtmlHelper.PAGEMENU,"Configure Replication",
                              "replconfig.jsp", siteAdminFlag) %><br /><br/>
      <%= HtmlHelper.menuItem(HtmlHelper.PAGEMENU,"Configure Local Tracking",
                              "localtracking.jsp", siteAdminFlag) %><br /><br/>
    </div>

    <!--  Remove this table when we know what content to put here. --!>
    <table width="100%" height="400">
      <tr><td></td></tr>
    </table>   
    <!--   End   --!> 

    <jsp:include page="/footer.jsp" />
  </body>
</html>


