<%--
  -- Reciprocal Net project
  -- /admin/managelabs.jsp
  --
  -- 22-Jul-2002: hclin wrote first draft
  -- 09-Aug-2002: hclin fixed bug #295
  -- 21-Aug-2002: eisiorho fixed bug #376
  -- 13-Sep-2002: jobollin corrected title capitalization per task 332
  -- 20-sep-2002: eisiorho fixed bug #469
  --%>

<%--
    The session="true" and isThreadSafe="true" attributes of the page
    directive are the default values; they simply serve as reminders,
    and as place holders should the defaults need to be overriden.  A
    specific error page could also be specified here; because it is not,
    any specified in this application's web.xml file will be used as a default
--%>
<%@page session="true" isThreadSafe="true"
        info="Site Administration - Manage Labs"
        import="org.recipnet.site.wrapper.HtmlHelper"
        import="org.recipnet.site.container.LabInfo"
        import="java.util.List"
        import="java.util.Iterator" %>
<%@include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>

<%
    /*
     * This page is accessible only to site and lab administrators.
     * Request unauthenticated users to authenticate:
     */
    if ( !authController.checkUserAuthenticationStatus() ) {
        request.setAttribute("reason", authController.AUTHENTICATION_REQUIRED);
%>
        <jsp:forward page="/login.jsp" />
<%
    /*
     * Make certain that an authenticated user is either a lab or a site
     * admin
     */
    } else if (!authController.canAdministerLabs()) {
        request.setAttribute("reason", authController.INSUFFICIENT_ACCESS);
%>
        <jsp:forward page="/login.jsp" />
<%
    }
    List labInfoList = pageHelper.getAllLabInfo();
    Iterator iterator = labInfoList.iterator();
    LabInfo labInfo;
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Reciprocal Net - <%=getServletInfo()%></title>
    <link href="../recipnet.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo()%>" />
    </jsp:include>
    <br />
    <table class="adminFormTable" border="0" cellspacing="0">
<%
    boolean color = false;
    while (iterator.hasNext()) {
           labInfo = (LabInfo)iterator.next();
%>
      <tr class="rowColor<%=color%>">
        <th class="threeColumnLeft"><%=labInfo.name%></th>
<%
      if (authController.canAdministerLab(labInfo.id)) {
%>
        <td class="threeColumnMiddle"><a href="editlab.jsp?labId=<%=labInfo.id%>">
<%      if (!labInfo.isActive) {   %>
            View this lab's inforamtion</a> (This lab is deactivated)
<%      } else { %>
            Edit this lab</a>
<%      } %>
        </td>
        <td class="threeColumnRight">
<%      if (labInfo.isActive) {   %>
          <a href="manageproviders.jsp?labId=<%=labInfo.id%>">Manage this lab's provider(s)</a>
<%      } else {  %>
          &nbsp;
<%      } %>
        </td>
<%    } else {  %>
        <td class="threeColumnRight">&nbsp;</td>
        <td class="threeColumnRight">&nbsp;</td>
<%    } %>
      </tr>
<%
      color = !color;
    }
%>
    </table>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
