<%--
  -- Reciprocal Net project
  -- /admin/manageproviders.jsp
  --
  -- 22-Jul-2002: hclin wrote first draft
  -- 09-Aug-2002: hclin fixed bug #295
  -- 21-Aug-2002: eisiorho removed TODO, task #373
  -- 13-Sep-2002: jobollin corrected title capitalization per task 332
  --%>

<%--
    The session="true" and isThreadSafe="true" attributes of the page
    directive are the default values; they simply serve as reminders,
    and as place holders should the defaults need to be overriden.  A
    specific error page could also be specified here; because it is not,
    any specified in this application's web.xml file will be used as a default
--%>
<%@page session="true" isThreadSafe="true"
        info="Site Administration - Manage Providers"
        import="org.recipnet.site.wrapper.HtmlHelper"
        import="org.recipnet.site.container.ProviderInfo"
        import="org.recipnet.site.container.LabInfo"
        import="java.util.List"
        import="java.util.Iterator" %>
<%@include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>

<%
    /*
     * This page is accessible only to site and lab administrators.
     * Request unauthenticated users to authenticate:
     */
    if ( !authController.checkUserAuthenticationStatus() ) {
        request.setAttribute("reason", authController.AUTHENTICATION_REQUIRED);
%>
        <jsp:forward page="/login.jsp" />
<%
    }
    /* Check if the labId is valid */
    int labId = LabInfo.INVALID_LAB_ID;
    String labIdStr = request.getParameter("labId");
    if (labIdStr == null) {
       ((HttpServletResponse) response).sendError(
               HttpServletResponse.SC_BAD_REQUEST);
    } else {
        try {

            labId = Integer.parseInt(labIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
        }
    }

    /*
     * Make certain that an authenticated user is either a lab admin or a site admin
     * and can edit providers from this specified lab
     */
    if (!authController.canAdministerLab(labId)) {
        request.setAttribute("reason", authController.INSUFFICIENT_ACCESS);
%>
        <jsp:forward page="/login.jsp" />
<%
    }
    LabInfo labInfo = pageHelper.getLabInfo(labId);
    List providerInfoList = pageHelper.getAllProviderInfo(labId);
    Iterator iterator = providerInfoList.iterator();
    ProviderInfo providerInfo;
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Recipnet Net - <%=getServletInfo()%></title>
    <link href="../recipnet.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo()%>" />
    </jsp:include>
    <br />
    <p class="headerFont1">Provider accounts associated with this lab - <%=labInfo.name%> (<%=labInfo.id%>):</p>
    <table class="adminFormTable" border="0" cellspacing="0">
<%
    boolean color = false;
    while (iterator.hasNext()) {
           providerInfo = (ProviderInfo)iterator.next();
%>
      <tr class="rowColor<%=color%>">
        <th class="threeColumnLeft"><%=providerInfo.name%></th>
        <td class="twoColumnRight">
<%      if (!providerInfo.isActive) {  %>
        <a href="editprovider.jsp?labId=<%=labId%>&providerId=<%=providerInfo.id%>">
           View this provider's information</a> (This provider is deactivated)
<%      } else {  %>
<a href="editprovider.jsp?labId=<%=labId%>&providerId=<%=providerInfo.id%>">Edit this provider</a>
<%      }         %>
        </td>
      </tr>
<%
      color = !color;
    }
%>
      <tr class="rowColor<%=color%>">
        <td colspan="2">
          <a href="editprovider.jsp?labId=<%=labId%>&providerId=<%=ProviderInfo.INVALID_PROVIDER_ID%>">Add a new provider</a>
        </td>
      </tr>
    </table>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
