<%--
  -- Reciprocal Net project
  -- index.jsp
  --
  -- 22-Jul-2002: hclin wrote first draft
  -- 11-Sep-2002: jobollin performed task #427: remove log in box from
  --              index.jsp
  -- 15-Nov-2002: ekoperda added some explanatory text to the body of the page
  --%>

<%@page session="true" isThreadSafe="true"
        info="Site Home" 
        import="org.recipnet.site.wrapper.HtmlHelper" %>  
<%@include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>

<%
    /* This page only accepts GET requests */

    if ( ! "GET".equals(request.getMethod()) ) {
        ((HttpServletResponse) response).sendError(HttpServletResponse.SC_METHOD_NOT_ALLOWED);
        return;
    } 
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Reciprocal Net - <%=getServletInfo() %></title>
    <link href="recipnet.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <jsp:include page="/header.jsp">
      <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
    <table width="500" height="400" border="0" cellpadding="0" cellspacing="0">
      <tr valign="top">
        <td width="75" class="pageBar">
          &nbsp;
        </td>
        <td width="25">
          &nbsp;
        </td>
        <td>
          &nbsp;
          <p>
            This is one of the many sites in the Reciprocal Net Site Network
            and is operated by the <a href="/">laboratory</a> noted in the 
            upper-right corner of this page. &nbsp; Use the menu bar above to
            navigate to samples in this site's database. &nbsp; Select samples
            are available to the general public without authentication. &nbsp;
            Authorized users, please <a href="login.jsp">log in</a> first.
          </p>
          <p>
            The Reciprocal Net Site Network is a distributed database for
            molecular structure data and is run by participating
            crystallography labs across the United States. &nbsp; Each entry in
            the database generally describes a single crystal structure that
            was synthesized or isolated by a research chemist and was analyzed
            by means of X-ray crystallography. &nbsp; You may jump to another 
            site's database by clicking the 
            <a href="http://www.reciprocalnet.org/master/sitelist.html">other 
            sites</a> link. &nbsp; Or, you may visit the master server at 
            <a href="http://www.reciprocalnet.org/">ReciprocalNet.org</a> for
            more information.
          </p>
        </td>
      </tr>
    </table>
    <jsp:include page="/footer.jsp" />
  </body>
</html>

