<%--
  -- Reciprocal Net project
  -- jamm.jsp
  --
  -- 30-Jul-2002: hclin wrote first draft
  -- 07-Aug-2002: hclin fixed bug #293
  -- 13-Sep-2002: jobollin corrected title capitalization per task 332
  -- 29-Oct-2002: jobollin adjusted applet parameters as part of task 510
  -- 05-Nov-2002: jobollin adjusted applet parameters further and performed
  --              minor general modifications
  -- 20-Nov-2002: jobollin modified JammSupport URLs
  -- 17-Dec-2002: jobollin removed applet parameters specifying table.dat as
  --              part of task #509
  --%>
<%--
    The session="true" and isThreadSafe="true" attributes of the page
    directive are the default values; they simply serve as reminders,
    and as place holders should the defaults need to be overriden.  A
    specific error page could also be specified here; because it is not,
    any specified in this application's web.xml file will be used as a default
--%>
<%@page session="true" isThreadSafe="true"
        info="JaMM Viewer"
        import="org.recipnet.site.container.RepositoryDirectory" 
        import="org.recipnet.site.container.RepositoryFile"
        import="org.recipnet.site.container.SampleInfo"
        import="java.util.ArrayList"
        import="java.util.Iterator"
        import="java.util.LinkedHashMap"
        import="java.util.List"%>
<%@include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>

<%
    int sampleId = SampleInfo.INVALID_SAMPLE_ID;
    String sampleIdStr = request.getParameter("sampleId");

    if (sampleIdStr == null) {
       ((HttpServletResponse) response).sendError(
               HttpServletResponse.SC_BAD_REQUEST);
       return;
    } else {
        try {
            sampleId = Integer.parseInt(sampleIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
          return;
        }
    }

    if ( !authController.canSeeSample(sampleId) ) {
         request.setAttribute("reason",
                 AuthenticationController.INSUFFICIENT_ACCESS);
%>
<jsp:forward page="/login.jsp" />
<%
    }
    String crtFile = request.getParameter("crtFile");
    String jamm = request.getParameter("jamm");
    String contextPath = ((HttpServletRequest) request).getContextPath();
    String defaultJamm = "JaMM2";
    Iterator dirFileIterator;
    List crtFileList = new ArrayList();
    String dirFileStr;
    String fileExtension = ".crt";
    boolean findCrtFile = false;
    LinkedHashMap jammMap = new LinkedHashMap();
    Iterator mapIterator;

    jammMap.put("JaMM1", "works with any Java-capable browser");
    jammMap.put("JaMM2", "requires Sun Java plug-in 1.2 or higher (1.4 recommended)");
    jammMap.put("miniJaMM", "works with any Java-capable browser");
    // jammMap.put("JaMMed", "requires Sun Java plug-in 1.2 or higher (1.4 recommend)");

    pageHelper.retrieveSingleSample(sampleId);
    pageHelper.retrieveRepositoryDir(sampleId);

    if (crtFile == null || crtFile.equals("")) {
        crtFile = pageHelper.getSampleLocalLabId()+fileExtension;
    }
    if (jamm == null || jamm.equals("")) {
        jamm = defaultJamm;
    }    
%>  
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Reciprocal Net - <%=getServletInfo() %></title>
    <link href="recipnet.css" rel="stylesheet" type="text/css" />
  </head>
  <body><br />
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
<% 
  if (pageHelper.getRepositoryDirStatus() == RepositoryDirectory.DATADIR_OK) {
      int ticketId=pageHelper.grantNewTicket();
      dirFileIterator = pageHelper.getRepositoryDirFiles().iterator();

    /** Check if the default or requested crt file is in the list */
    while(dirFileIterator.hasNext()) {
          dirFileStr = ((RepositoryFile)dirFileIterator.next()).name.trim();
          if (dirFileStr.substring(dirFileStr.length()-fileExtension.length()).equals(fileExtension)) {
              crtFileList.add(dirFileStr);
              if (dirFileStr.equals(crtFile)) {     
                  findCrtFile = true;
              }
          }
    }  
    
    dirFileIterator = crtFileList.iterator();        
    if(!findCrtFile && dirFileIterator.hasNext()) { 
           crtFile = (String)(dirFileIterator.next());
    }

    /** 
    /* If the default or requested crt file is not in the list,
    /* set the default crt file to the first crt file in the list.
     */  
    if (!crtFileList.isEmpty()){ 
%>
  <table>
    <tr>
    <td>

<% if (jamm.equals("JaMM2")) { %>
    <object classid="clsid:8AD9C840-044E-11D1-B3E9-00805F499D93" width="600" height="500"
            codebase="http://java.sun.com/products/plugin/autodl/jinstall-1_4_0-win.cab#Version=1,2,0,0">
      <param name = "code" value = "org.recipnet.site.jamm.jamm2.JaMM.class" />
      <param name = "archive" value = "applets/jamm/JaMM2.jar" />
      <param name = "type" value = "application/x-java-applet;version=1.2" />
      <param name = "model" value = "<%=pageHelper.getRepositoryDirUrl()%><%=crtFile%>?ticket=<%=ticketId%>" />
      <param name = "sampleId" value = "<%=sampleId%>" />
      <param name = "color" value = "0x9F9F9F" />
      <param name = "line" value = "<%=contextPath%>/servlet/jammsupport" />
      <param name = "ortep" value = "<%=contextPath%>/servlet/jammsupport" />
      <param name = "render" value = "<%=contextPath%>/servlet/jammsupport" />
      <comment>
        <embed 
          type="application/x-java-applet;version=1.2" 
          java_code = "org.recipnet.site.jamm.jamm2.JaMM.class" 
          java_archive = "applets/jamm/JaMM2.jar" 
          width = "600" height = "500"  
          model = "<%=pageHelper.getRepositoryDirUrl()%><%=crtFile%>?ticket=<%=ticketId%>" 
          sampleId="<%=sampleId%>"
          color = "0x9F9F9F" 
          line="<%=contextPath%>/servlet/jammsupport"
          ortep = "<%=contextPath%>/servlet/jammsupport"
          render = "<%=contextPath%>/servlet/jammsupport"
          pluginspage="http://java.sun.com/getjava/">
        </embed>
      </comment>
    </object>

<% } else if (jamm.equals("JaMM1")) { %>
          <applet code="org.recipnet.site.jamm.jamm1.JaMM.class" codebase="applets/jamm/" 
                  archive="JaMM1.jar" width="400" height="400">
             <param name="model" value="<%=pageHelper.getRepositoryDirUrl()%><%=crtFile%>?ticket=<%=ticketId%>" />
             <param name = "sampleId" value = "<%=sampleId%>" />
             <param name = "ortep" value = "<%=contextPath%>/servlet/jammsupport" />
             <param name = "render" value = "<%=contextPath%>/servlet/jammsupport" />
          </applet>

<% } else if (jamm.equals("miniJaMM"))  { %>
          <applet code="org.recipnet.site.jamm.minijamm.miniJaMM.class" 
                  codebase="applets/jamm/" archive="miniJaMM.jar" width="400"
                  height="400">
              <param name="background" value="eeeeee" />
              <param name="border" value="true" />
              <param name="model" value="<%=pageHelper.getRepositoryDirUrl()%><%=crtFile%>?ticket=<%=ticketId%>" />
              <param name="textcolor" value="000000" />
          </applet>

<% } else if (jamm.equals("JaMMed"))   { %>
          <object classid = "clsid:8AD9C840-044E-11D1-B3E9-00805F499D93"
                  width = "400" height = "400"  
                  codebase = "http://java.sun.com/products/plugin/autodl/jinstall-1_4_0-win.cab#Version=1,2,0,0">
            <param name = "code" value = "org.recipnet.site.jamm.jamm2.JaMMed.class"  />
            <param name = "archive" value = "applets/jamm/JaMMed.jar"  />
            <param name = "type" value = "application/x-java-applet;version=1.2" />
            <param name = "model" value = "<%=pageHelper.getRepositoryDirUrl()%><%=crtFile%>?ticket=<%=ticketId%>" />
            <param name = "color" value = "0x9F9F9F" />
            <param name = "border" value = "true"  />
            <comment>
              <embed 
                 type="application/x-java-applet;version=1.2" 
                 java_code = "org.recipnet.site.jamm.jamm2.JaMMed.class" 
                 java_archive = "applets/jamm/JaMMed.jar" 
                 width = "400" height = "400"  
                 model = "<%=pageHelper.getRepositoryDirUrl()%><%=crtFile%>?ticket=<%=ticketId%>" 
                 color = "0x9F9F9F" 
                 border = "true"
                 pluginspage="http://java.sun.com/getjava/">
              </embed>
            </comment>
          </object>
<%
   }
%>
  </td>
  <td>
<% 
        if(!findCrtFile) { 
%>

<b><%=crtFile%></b><br />

<%
         while(dirFileIterator.hasNext()) {
               dirFileStr = (String)(dirFileIterator.next());      
%>

<a href="jamm.jsp?sampleId=<%=sampleId%>&crtFile=<%=dirFileStr%>&jamm=<%=jamm%>"><%=dirFileStr%></a><br />

<%  
         }
      } else {

         while(dirFileIterator.hasNext()) {
               dirFileStr = (String)(dirFileIterator.next());
           if (dirFileStr.equals(crtFile)) {      
%>

<b><%=dirFileStr%></b><br />              

<%
            } else { 
%>

<a href="jamm.jsp?sampleId=<%=sampleId%>&crtFile=<%=dirFileStr%>&jamm=<%=jamm%>"><%=dirFileStr%></a><br />

<%
           }          
         }  
     } 
%>
<br /><br />
<a href="showsample.jsp?sampleId=<%=sampleId%>">Sample Infomation</a><br />

<% 
    if ( authController.canEditSample(sampleId) ) {
         request.setAttribute("reason",
                 AuthenticationController.INSUFFICIENT_ACCESS);
%>
<a href="lab/sample.jsp?sampleId=<%=sampleId%>">Edit Sample</a><br />

<%  } %>
  </td>
  </tr>
</table><hr />

<%
    /** Display options for jamm */
    mapIterator = jammMap.keySet().iterator();
    while (mapIterator.hasNext()) {
         String jammType = (String) mapIterator.next();
         if (jammType.equals(jamm)) {
%>
  
<b><%=jamm%></b> - <%=(String)jammMap.get(jammType)%><br />

<%
        } else {
%>

<a href="jamm.jsp?sampleId=<%=sampleId%>&crtFile=<%=crtFile%>&jamm=<%=jammType%>"><%=jammType%></a>
 - <%=(String)jammMap.get(jammType)%><br />
<%
        }      
    }
  }
} else { 
%>
<p class="errorMessage">Repository is not available.</p>
<% }   %>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
