<%--
  -- Reciprocal Net Project
  --
  -- jammline.jsp
  --
  -- 22-Oct-2002: jobollin wrote first draft
  -- 12-Dec-2002: jobollin inserted the context path into the stylesheet link
  --              (task #642)
  --%>
<%@page session="true" isThreadSafe="true" info="Line Drawing"
        import="org.recipnet.site.wrapper.HtmlHelper" %>
<%
    /*
     * This JSP should only be invoked by means of JammSupport forwarding a
     * request to it.  JammSupport must assure that the request has the
     * following attributes:
     *
     * epsKey -      a Long representing the key to an EPS file
     * jpegKey -     a Long representing the key to a JPEG image file
     * sampleTitle - a String to be used as part of the page title
     *
     * if one or more of these attributes is missing then the page sends a
     * 403 (Forbidden) response
     */
    HttpServletRequest httpRequest = (HttpServletRequest) request;

    Long epsKey = (Long) request.getAttribute("epsKey");
    Long jpegKey = (Long) request.getAttribute("jpegKey");
    String sampleTitle = (String) request.getAttribute("sampleTitle");

    // The JammSupport servlet should have set all of these:
    if (epsKey == null || jpegKey == null || sampleTitle == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_FORBIDDEN);
    }

    String contextPath = httpRequest.getContextPath();
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Reciprocal Net - <%=getServletInfo() %></title>
    <link href="<%=contextPath%>/recipnet.css" rel="stylesheet"
          type="text/css" />
  </head>
  <body>
    <img class="recipnetImage" alt="Reciprocal Net"
         src="<%=contextPath%>/images/recipnet-small.jpeg" />
    <br /><h1>Line Drawing of <%= sampleTitle %></h1>
    <img alt="chemical line drawing"
        src="<%=contextPath%>/servlet/fileretrieve/jamm-line.jpeg?key=<%=jpegKey%>" />
    <hr />
    <ul>
      <li><a href="<%=contextPath%>/servlet/fileretrieve/jamm-line.eps?key=<%=
        epsKey %>">Postscript Version</a></li>
      <li><a href="<%=contextPath%>/servlet/fileretrieve/jamm-line.jpeg?key=<%=
         jpegKey %>">JPEG Version</a></li>
    </ul>
  </body>
</html>

