<%--
  -- Reciprocal Net project
  -- addcitation.jsp
  --
  -- 26-Jul-2002: eisiorho wrote first draft
  -- 13-Sep-2002: jobollin fixed line delimiters (Task 433)
  -- 04-Nov-2002: ekoperda got rid of all code for the REFERENCE_ADDED action
  --%>
<%@ page session="true" isThreadSafe="true"
        info="Add Citation"
        import="org.recipnet.site.wrapper.HtmlHelper"
        import="org.recipnet.site.container.SampleInfo"
        import="org.recipnet.site.container.SampleHistoryInfo" %>
<%@ include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>
<%
    if ( !authController.checkUserAuthenticationStatus() ) {
        request.setAttribute("reason",
                AuthenticationController.AUTHENTICATION_REQUIRED); %>
        <jsp:forward page="/login.jsp" /> <%
    }

    int sampleId = SampleInfo.INVALID_SAMPLE_ID;
    String sampleIdStr = request.getParameter("sampleId");
    if (sampleIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleId = Integer.parseInt(sampleIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
        if ( !authController.canEditSample(sampleId) ) {
            request.setAttribute("reason",
                    AuthenticationController.INSUFFICIENT_ACCESS); %>
            <jsp:forward page="/login.jsp" /> <%
        }
    }

    /*
     * If control reaches here then the user is authorized to edit the
     * sample specified in his request.
     */

    int sampleHistoryId = SampleHistoryInfo.INVALID_SAMPLE_HISTORY_ID;
    String sampleHistoryIdStr = request.getParameter("sampleHistoryId");
    if (sampleHistoryIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleHistoryId = Integer.parseInt(sampleHistoryIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
    }
    if ("".equals(HtmlHelper.nullToBlank(
            request.getParameter("addcitation_action")))) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
    }
    String choice = HtmlHelper.nullToBlank(request.getParameter(
            "addcitation_action"));
    if (choice.equals("Citation")) {
        /* Nothing to do; this action verb is valid */
    } else {
        /* All other action verbs are invalid */
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
    }
    pageHelper.retrieveSingleSample(sampleId, sampleHistoryId);
    boolean posted = false;
    String method = ((HttpServletRequest) request).getMethod();
    if ("POST".equals(method)) {
        posted = true;
        pageHelper.addCitation(sampleId, sampleHistoryId,
                authController.getUserId(),
                request.getRemoteAddr(),
                HtmlHelper.nullToBlank(request.getParameter("citation")),
                HtmlHelper.nullToBlank(request.getParameter("comments")));
        ((HttpServletResponse) response).sendRedirect("sample.jsp?sampleId=" 
                + pageHelper.getSampleId());
    } else if ( ! "GET".equals(method) ) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_METHOD_NOT_ALLOWED );
        return;
    }

    /*
     * If control reaches here then we have either a POST request with a
     * validation error or a GET request. Can go on and receive info to
     * display.
     */
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
  <link rel="stylesheet"
        href="../recipnet.css"
        type="text/css">
    <title>Reciprocal Net - <%= getServletInfo() %></title>
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include> <%
    if (posted) { %>
        <p class="errorMessage">
          Validation Error -- please check your entries and resubmit
        </p> <%  
    } %>
    <p class="pageInstructions">
      Enter the comments, citations, and publication reference on the
      form below and click the &quot;Submit&quot; button to record it.
    </p>
    <center> <%  
      if (choice.equals("Citation")) { %>
          <form method="POST">
            <input type="hidden" name="sampleId" value="<%=sampleId%>">
            <table class="formTable">
              <tr>
                <th colspan="2">Citation</th>
              </tr>
              <tr>
                <td colspan="2" align="center">
                  <textarea name="citation" id="citation" rows="12"
                          cols="45" wrap="hard"><%= 
                    HtmlHelper.nullToBlank(request.getParameter("citation"))
                    %></textarea>
                </td>
              </tr>         
              <tr>
                <th colspan="2">Comments</th>
              </tr>
              <tr>
                <td colspan="2" align="center">
                  <textarea name="comments" id="comments" rows="12" cols="45"
                          wrap="hard"><%= HtmlHelper.nullToBlank(
                          request.getParameter("comments")) %></textarea>
                </td>
              </tr>
            </table>
            <input type="submit" value="Submit" />
            <input type="reset" value="Reset" />
          </form> <%
      } %>
    </center>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
