<%--
  -- Reciprocal Net project
  -- changeacl.jsp
  --
  -- 28-Jul-2002: eisiorho wrote first draft
  -- 14-Aug-2002: eisiorho fixed bug #359
  -- 19-Aug-2002: eisiorho changed changeacl.jsp to reflect change in
  --              PageHelper.java, task #362
  -- 13-Sep-2002: jobollin fixed line delimiters (Task 433)
  --%>
<%@ page session="true" isThreadSafe="true"
        info="Change Access Level"
        import="org.recipnet.site.wrapper.HtmlHelper"
        import="org.recipnet.site.container.SampleHistoryInfo"
        import="org.recipnet.site.container.UserInfo"
        import="org.recipnet.site.container.SampleAccessInfo"
        import="org.recipnet.site.container.SampleInfo"
%>
<%@ include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>
<%
    if ( !authController.checkUserAuthenticationStatus() ) {
        request.setAttribute("reason",
                AuthenticationController.AUTHENTICATION_REQUIRED);
%>
<jsp:forward page="/login.jsp" />
<%
    }

    int sampleId = SampleInfo.INVALID_SAMPLE_ID;
    String sampleIdStr = request.getParameter("sampleId");
    if (sampleIdStr == null) {
        ((HttpServletResponse) response).sendError(HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleId = Integer.parseInt(sampleIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
        if ( !authController.canEditSample(sampleId) ) {
            request.setAttribute("reason", AuthenticationController.INSUFFICIENT_ACCESS);
%>
<jsp:forward page="/login.jsp" />
<%
        }
    }

    /*
     * If control reaches here then the user is authorized to edit the
     * sample specified in his request.
     */

    int sampleHistoryId = SampleHistoryInfo.INVALID_SAMPLE_HISTORY_ID;
    String sampleHistoryIdStr = request.getParameter("sampleHistoryId");
    if (sampleHistoryIdStr == null) {
        ((HttpServletResponse) response).sendError(HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleHistoryId = Integer.parseInt(sampleHistoryIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
    }
    pageHelper.retrieveSingleSample(sampleId, sampleHistoryId);
    pageHelper.retrieveActiveUsers();
    int i = 0; // For 'for' loops.
    String method = ((HttpServletRequest) request).getMethod();
    if ("POST".equals(method)) {

        //To make sure that the program doesn't generate a null pointer,
        //this checks to make sure there is a value there.

        pageHelper.startCommitAccessLevelChange();
        int count = Integer.parseInt(request.getParameter("count"));
        for (i = 0; i < count; i++) {
            String accesslevelFieldName = "accesslevelFieldName" + i;
            String userIdFieldName = "userIdFieldName" + i;
            try {
                int usrId = Integer.parseInt(request.getParameter(userIdFieldName));
                int access = Integer.parseInt(request.getParameter(accesslevelFieldName));

                if (access == SampleAccessInfo.INVALID_ACCESS || access == SampleAccessInfo.READ_WRITE || access == SampleAccessInfo.READ_ONLY) {
                    pageHelper.putUserAccessLevel(usrId, access);
                } else {
                    ((HttpServletResponse) response).sendError(HttpServletResponse.SC_BAD_REQUEST);
                    return;
                }
            } catch (NumberFormatException nfe) {
                /* Validation Error -- drop through as if this was a GET request */
            }
        }
        pageHelper.endCommitAccessLevelChange(sampleId, sampleHistoryId,
                                              authController.getUserId(),
                                              request.getRemoteAddr(),
                                      HtmlHelper.nullToBlank(request.getParameter("comments")) );


        ((HttpServletResponse) response).sendRedirect("sample.jsp?sampleId=" + sampleId);
    } else if ( ! "GET".equals(method) ) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_METHOD_NOT_ALLOWED );
        return;
    }

    /*
     * If control reaches here then we have either a POST request with a
     * validation error or a GET request. Can go on and receive info to
     * display.
     */
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
  <link rel="stylesheet"
        href="../recipnet.css"
        type="text/css">
    <title>Reciprocal Net - <%= getServletInfo() %></title>
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
    <center>
      <p class="pageInstructions">
        Every active user account on this site is listed below. To change<br />
        the access level of each user to this particular sample, fill out the<br />
        form below and then click the &quot;Submit&quot; button to record it.
      </p>
      <form method="POST">
        <input type="hidden" name="sampleId" value="<%=sampleId%>">
        <input type="hidden" name="sampleHistoryId" value="<%=sampleHistoryId%>">
        <table cellpadding="5" cellspacing="2" width="840" class="formTable">
          <tr>
            <th colspan="3">Change Access Control List</th>
            <th>Read/Write</th>
            <th>Read Only</th>
            <th>No Access</th>
          </tr>
<%
    do {
        int userId = pageHelper.getUserId();
        String accesslevelFieldName = "accesslevelFieldName" + i;
        String userIdFieldName = "userIdFieldName" + i;
        i++;
%>
          <tr>
            <td colspan="2" align="left">
              User Name:&nbsp;&nbsp;&nbsp;&nbsp;<%= pageHelper.getUserFullName() %>
              <input type="hidden" name="<%= userIdFieldName %>" id="<%= userIdFieldName %>"
                     value="<%= userId %>">
            </td>
            <td align="left">
              Affiliation:&nbsp;&nbsp;&nbsp;&nbsp;<%= pageHelper.getUserAffiliation() %>
            </td>

            <%--The read/write radio button should be present for each user --%>
            <td>
              <input type="radio" name="<%= accesslevelFieldName %>" id="<%= accesslevelFieldName %>"
                      value="<%= SampleAccessInfo.READ_WRITE %>" <%=pageHelper.getUserAccessLevel() == SampleAccessInfo.READ_WRITE ? "checked" : ""%>>
            </td>
            <td>
<%
            // The read-only radio button should be present for everybody except lab users associated with this sample
            if (pageHelper.isUserLabUser() && pageHelper.getUserLabId() == pageHelper.getSampleLabId()) {
%>
              &nbsp;
<%          } else { %>
              <input type="radio" name="<%= accesslevelFieldName %>" id="<%= accesslevelFieldName %>"
                      value="<%= SampleAccessInfo.READ_ONLY %>" <%=pageHelper.getUserAccessLevel() == SampleAccessInfo.READ_ONLY ? "checked" : ""%>>
<%          } %>
            </td>
            <td>
            <%-- The only time INVALID_ACCESS button is not shown is when the user is a Lab User or Provider User associated with this sample, or when
                 the sample has been made public --%>
<%          if (pageHelper.isSamplePublic()
                || (pageHelper.isUserProviderUser() && pageHelper.getUserProviderId() == pageHelper.getSampleProviderId())
                || (pageHelper.isUserLabUser() && pageHelper.getUserLabId() == pageHelper.getSampleLabId()) ) {
%>
              &nbsp;
<%
            } else {
%>
              <input type="radio" name="<%= accesslevelFieldName %>" id="<%= accesslevelFieldName %>"
                     value="<%= SampleAccessInfo.INVALID_ACCESS %>" <%=(pageHelper.getUserAccessLevel() == SampleAccessInfo.INVALID_ACCESS) ? "checked" : ""%>>
<%          } %>
            </td>
          </tr>
          <tr>
            <td colspan="6">&nbsp;<hr /></td>
          </tr>
<%  } while (pageHelper.moveNextUserInfo()); %>
          <tr>
            <th colspan="6">Comments</th>
          </tr>
          <tr>
            <td colspan="6"> <!--align="center"-->
              <textarea name="comments" id="comments" rows="12"
                        cols="45" wrap="hard"><%= HtmlHelper.nullToBlank(request.getParameter("comments")) %></textarea>
            </td>
          </tr>
        </table>
        <input type="submit" value="Submit">
        <input type="reset" value="Reset">
        <input type="hidden" value="<%= i %>" name="count" id="count">
      </form>
    </center>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
