<%--
  -- gatherdata.jsp
  --
  -- 17-Jul-2002: jobollin wrote first draft
  -- 06-Aug-2002: jobollin fixed bug 252
  -- 06-Aug-2002: jobollin fixed bugs 263 and 266
  -- 22-Aug-2002: jobollin fixed bugs 262 and 280
  -- 29-Aug-2002: leqian added localtracking support
  -- 10-Sep-2002: eisiorho added appropriate measurement unit for "scientific
  --              data"
  -- 18-Sep-2002: ekoperda fixed bug #462 (incorrect symbol for Angstroms)
  -- 14-Nov-2002: adharurk added combo box for Crystallographer name.
  --%>
<%@ page
         session="true" isThreadSafe="true"
         info="Record Initial Sample Data"
         import="org.recipnet.site.wrapper.HtmlHelper"
         import="org.recipnet.site.container.SampleInfo"
         import="org.recipnet.site.container.UserInfo"
         import="org.recipnet.site.container.LocalTrackingConfig"
         import="org.recipnet.site.container.SampleDataInfo"
         import="org.recipnet.site.container.SampleHistoryInfo"
         import="org.recipnet.site.container.SampleTextInfo" 
         import="java.util.List"
         import="java.util.Iterator" %>
<%@ include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>
<%
    if ( !authController.checkUserAuthenticationStatus() ) {
        request.setAttribute("reason",
                AuthenticationController.AUTHENTICATION_REQUIRED);
%>
<jsp:forward page="/login.jsp" />
<%
    }
    int sampleId = SampleInfo.INVALID_SAMPLE_ID;
    String sampleIdStr = request.getParameter("sampleId");
    if (sampleIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleId = Integer.parseInt(sampleIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
        if ( !authController.canEditSample(sampleId) ) {
            request.setAttribute("reason",
                    AuthenticationController.INSUFFICIENT_ACCESS);
%>
<jsp:forward page="/login.jsp" />
<%
        }
    }

    /*
     * If control reaches here then the user is authorized to edit the
     * sample specified in his request.
     */

    int sampleHistoryId = SampleHistoryInfo.INVALID_SAMPLE_HISTORY_ID;
    String sampleHistoryIdStr = request.getParameter("sampleHistoryId");
    if (sampleHistoryIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleHistoryId = Integer.parseInt(sampleHistoryIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
    }

    pageHelper.retrieveSingleSample(sampleId, sampleHistoryId);
    boolean posted = false;                                                    
    String method = ((HttpServletRequest) request).getMethod();
    if ("POST".equals(method)) {
	pageHelper.retrieveLocalTrackingConfig();
        posted = true;
        try {
            String fieldValue;
            int fieldType;
            while (pageHelper.moveNextLocalTrackingField( 
                    LocalTrackingConfig.VISIBLE_ON_GATHERDATA)) {
                fieldType=pageHelper.getCurrentLocalTrackingFieldTextType();
                fieldValue= request.getParameter("localTracking"+fieldType);
	        if (null==fieldValue || fieldValue.trim().equals("")) {
	       	    pageHelper.modifyLtaDuringNextAction(fieldType, null);
	        } else {
		    pageHelper.modifyLtaDuringNextAction( 
                          fieldType, fieldValue);
                }
	    }
            pageHelper.gatherSampleData(
                    sampleId,
                    sampleHistoryId,
                    authController.getUserId(),
                    request.getRemoteAddr(),
                    request.getParameter("crystallographer"),
                    HtmlHelper.validateOptionalDouble(-273.15d,
                            SampleDataInfo.INVALID_DOUBLE_VALUE,
                            request.getParameter("temp")),
                    request.getParameter("color"),
                    HtmlHelper.validateOptionalDouble( 1.0d,
                            SampleDataInfo.INVALID_DOUBLE_VALUE,
                            request.getParameter("cellA")),
                    HtmlHelper.validateOptionalDouble( 1.0d,
                            SampleDataInfo.INVALID_DOUBLE_VALUE,
                            request.getParameter("cellB")),
                    HtmlHelper.validateOptionalDouble( 1.0d,
                            SampleDataInfo.INVALID_DOUBLE_VALUE,
                            request.getParameter("cellC")),
                    HtmlHelper.validateOptionalDouble( 1.0d, 179.0d,
                            request.getParameter("cellAlpha")),
                    HtmlHelper.validateOptionalDouble( 1.0d, 179.0d,
                            request.getParameter("cellBeta")),
                    HtmlHelper.validateOptionalDouble( 1.0d, 179.0d,
                            request.getParameter("cellGamma")),
                    request.getParameter("comments") );
            ((HttpServletResponse) response).sendRedirect(
                    "sample.jsp?sampleId="+sampleId);
            return;
        } catch (NumberFormatException nfe) {
            /* Validation Error -- drop through as if this was a GET request */
        }
    } else if ( ! "GET".equals(method) ) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_METHOD_NOT_ALLOWED );
        return;
    }

    /*
     * If control reaches here then we have either a POST request with a
     * validation error or a GET request.
     */

    /* Initial values for the form fields: */
    String crystallographer = HtmlHelper.nullToDefault(
            request.getParameter("crystallographer"),
            HtmlHelper.nullToDefault(pageHelper.getNextAttributeValue(
                    SampleTextInfo.CRYSTALLOGRAPHER_NAME),
                    authController.getFullName() ) );
    String cellA = HtmlHelper.nullToDefault(request.getParameter("cellA"),
            HtmlHelper.doubleToString(pageHelper.getSampleA(), 3, 5, ""));
    String cellB = HtmlHelper.nullToDefault(request.getParameter("cellB"),
            HtmlHelper.doubleToString(pageHelper.getSampleB(), 3, 5, ""));
    String cellC = HtmlHelper.nullToDefault(request.getParameter("cellC"),
            HtmlHelper.doubleToString(pageHelper.getSampleC(), 3, 5, ""));
    String cellAlpha = HtmlHelper.nullToDefault(
            request.getParameter("cellAlpha"),
            HtmlHelper.doubleToString( 
                    pageHelper.getSampleAlpha(), 2, 4, "90"));
    String cellBeta = HtmlHelper.nullToDefault(
            request.getParameter("cellBeta"),
            HtmlHelper.doubleToString(pageHelper.getSampleBeta(), 2, 4, "90"));
    String cellGamma = HtmlHelper.nullToDefault(
            request.getParameter("cellGamma"),
            HtmlHelper.doubleToString( 
                    pageHelper.getSampleGamma(), 2, 4, "90"));
    String temperature = HtmlHelper.nullToDefault(
            request.getParameter("temp"),
            HtmlHelper.doubleToString(pageHelper.getSampleT(), 1, 2, "25.0"));
    String color = HtmlHelper.nullToDefault(
            request.getParameter("color"),
            HtmlHelper.nullToBlank(pageHelper.getSampleColor()));
	pageHelper.retrieveLocalTrackingConfig();

%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Reciprocal Net - <%=getServletInfo() %></title>
    <link href="../recipnet.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
    <br/>
<%  if (posted) { %>
    <p class="errorMessage">Validation Error -- please check your entries and
      resubmit</p>
<%  } %>
    <p class="pageInstructions">
      Enter the basic crystal data on the form below and click the
      &quot;Record&nbsp;this&nbsp;data&quot; button to record it.
    </p>
    <form method="POST">
      <input type="hidden" name="sampleId" value="<%=sampleId%>">
      <%-- TODO: This table could use reformatting --%>
      <table class="formTable">
        <tr>
          <th>Laboratory</th>
          <td><%=pageHelper.getSampleLabName() %></td>
        </tr>
        <tr>
          <th>Sample</th>
          <td><%=pageHelper.getSampleLocalLabId() %></td>
        </tr>
        <tr>
          <th>Crystallographer</th>
          <td>
            <select name="crystallographer" id="crystallographer"> <%
              // Get a list of all the active scientific users that exist
              // within this sample's lab.
              List possibleCrystallographers =
                      pageHelper.getScientificUsersForLab( 
                      pageHelper.getSampleLabId());
              
              // Decide whether the logged-on user is present in the list.
              Iterator i = possibleCrystallographers.iterator();
              boolean foundCurrentUser = false;
              while (i.hasNext()) {
                  UserInfo user = (UserInfo) i.next();
                  if (user.id == authController.getUserId()) { 
                      foundCurrentUser = true;
                  }
              }

              // Display a dropdown list that contains all possible 
              // crystallographer names for this sample.  If the logged-on 
              // user's name is present in the list, his name should be the
              // default selection else the default selection is 'none'.
              if (!foundCurrentUser) { %> 
                  <option value="" selected="true">(none)</option> <%  
              } else { %>
                  <option value="">(none)</option> <%  
              }
              i = possibleCrystallographers.iterator();
              while (i.hasNext()) {
                  UserInfo user = (UserInfo) i.next();
                  if (authController.getUserId() == user.id) { %>
                      <option value="<%= user.fullName %>" selected = "true">
                          <%= user.fullName %></option> <%
                  } else { %>
                      <option value="<%= user.fullName %>">
                          <%= user.fullName %></option> <%
                  }
              } %>
            </select>
          </td>
        </tr>
<tr>
          <td colspan="2"> </td>
        </tr>
        <tr>
          <th colspan="2">Unit cell parameters</th>
        </tr>
        <tr>
          <th>a</th>
          <td><input type="text" name="cellA" size="12"
                     value="<%= cellA %>" /> &#197;</td>
        </tr>
        <tr>
          <th>b</th>
          <td><input type="text" name="cellB" size="12"
                     value="<%= cellB %>" /> &#197;</td>
        </tr>
        <tr>
          <th>c</th>
          <td><input type="text" name="cellC" size="12"
                     value="<%= cellC %>" /> &#197;</td>
        </tr>
        <tr>
          <th>alpha</th>
          <td><input type="text" name="cellAlpha" size="12"
                     value="<%= cellAlpha %>" /> &#176;</td>
        </tr>
        <tr>
          <th>beta</th>
          <td><input type="text" name="cellBeta" size="12"
                     value="<%= cellBeta %>" /> &#176;</td>
        </tr>
        <tr>
          <th>gamma</th>
          <td><input type="text" name="cellGamma" size="12"
                     value="<%= cellGamma %>" /> &#176;</td>
        </tr>
        <tr>
          <td colspan="2"> </td>
        </tr>
        <tr>
          <th>Temperature</th>
          <td><input type="text" name="temp" size="8"
                     value="<%= temperature %>" /> &#176; C</td>
        </tr>
        <tr>
          <th>Crystal color</th>
          <td><input type="text" name="color" size="8"
                     value="<%= color %>" /></td>
        </tr>
        <tr>
          <td colspan="2"> </td>
        </tr>
	<%
	while (pageHelper.moveNextLocalTrackingField( 
                LocalTrackingConfig.VISIBLE_ON_GATHERDATA)) { %>
	    <tr>
	     <th>
		<%=pageHelper.getCurrentLocalTrackingFieldName()%>:
	     </th>
	     <td>
		<% int ltType=pageHelper.getCurrentLocalTrackingFieldTextType(); %>
		<input type="text" name="localTracking<%=ltType%>"
			size="64" value="<%=posted?HtmlHelper.nullToBlank(
				request.getParameter("localTracking"+ltType)):
		HtmlHelper.nullToBlank(pageHelper.getNextAttributeValue(ltType))%>">
	     </td>
	    </tr> <%
		} %>
        <tr>
          <th colspan="2">Data collection comments</th>
        </tr>
        <tr>
         <td colspan="2"><textarea name="comments" rows="5" cols="80"><%=
                  HtmlHelper.nullToBlank(request.getParameter("comments"))
                  %></textarea></td>
        </tr>
        <tr>
         <td colspan="2"> </td>
        </tr>
        <tr>
          <td colspan="2">
            <input type="submit" name="submit" value="Record this data" />
            <input type="reset" name="reset" />
          </td>
        </tr>
      </table>
    </form>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
