<%--
  -- Reciprocal Net project
  -- localtracking.jsp
  --
  -- 07-Nov-2002: eisiorho wrote first draft
  -- 20-Nov-2002: ekoperda fixed bug #607
  --%>
<%@ page session="true" isThreadSafe="true"
         info="Modify Custom Fields"
         import="org.recipnet.site.wrapper.HtmlHelper"
         import="org.recipnet.site.container.SampleAnnotationInfo"
         import="org.recipnet.site.container.SampleAttributeInfo"
         import="org.recipnet.site.container.SampleTextInfo"
         import="org.recipnet.site.container.SampleDataInfo"
         import="org.recipnet.site.container.SampleInfo"
         import="org.recipnet.site.container.SampleHistoryInfo"
         import="org.recipnet.site.container.LocalTrackingConfig"
         import="java.util.Iterator"
         import="java.util.List" %>
<%@ include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>
<%
    if (!authController.checkUserAuthenticationStatus()) {
        request.setAttribute("reason",
                AuthenticationController.AUTHENTICATION_REQUIRED); %>
        <jsp:forward page="/login.jsp" /> <%
    }
    int sampleId = SampleInfo.INVALID_SAMPLE_ID;
    String sampleIdStr = request.getParameter("sampleId");
    if (sampleIdStr == null) {
        response.sendError(HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleId = Integer.parseInt(sampleIdStr);
        } catch (NumberFormatException nfe) {
            response.sendError(HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
        if ( !authController.canEditSample(sampleId) ) {
            request.setAttribute("reason",
                    AuthenticationController.INSUFFICIENT_ACCESS); %>
            <jsp:forward page="/login.jsp" /> <%
        }
    }

    /*
     * If control reaches this point then the user is authorized to edit the
     * sample specified in his request.
     */

    int sampleHistoryId = SampleHistoryInfo.INVALID_SAMPLE_HISTORY_ID;
    String sampleHistoryIdStr = request.getParameter("sampleHistoryId");
    if (sampleHistoryIdStr == null) {
        response.sendError(HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleHistoryId = Integer.parseInt(sampleHistoryIdStr);
        } catch (NumberFormatException nfe) {
            response.sendError(HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
    }

    pageHelper.retrieveSingleSample(sampleId, sampleHistoryId);
    pageHelper.retrieveLocalTrackingConfig();
    boolean posted = false;
    String method = ((HttpServletRequest) request).getMethod();
    if ("POST".equals(method)) {
        posted = true;

        // Retrieve the form parameters
        while (pageHelper.moveNextLocalTrackingField(
                LocalTrackingConfig.IGNORE_VISIBILITY)) {
            int fieldType = pageHelper.getCurrentLocalTrackingFieldTextType();
            String fieldValue =
                    request.getParameter("localTracking" + fieldType);
            if (null == fieldValue || fieldValue.trim().equals("")) {
                pageHelper.modifyLtaDuringNextAction(fieldType, null);
            } else {
                pageHelper.modifyLtaDuringNextAction(fieldType, fieldValue);
            }
        }

        // Do the workflow action to commit these changes, then redirect back
        // to the edit page
        pageHelper.modifySampleLta(sampleId, sampleHistoryId,
	        authController.getUserId(), request.getRemoteAddr(),
                HtmlHelper.nullToBlank(request.getParameter("comments")));
        response.sendRedirect("sample.jsp?sampleId="
                + pageHelper.getSampleId());
    } else if ( ! "GET".equals(method) ) {
        response.sendError(HttpServletResponse.SC_METHOD_NOT_ALLOWED );
        return;
    }

    /*
     * If control reaches this point then we have either a POST request with a
     * validation error or a GET request.
     */
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
  <link rel="stylesheet"
        href="../recipnet.css"
        type="text/css">
    <title>Reciprocal Net - <%= getServletInfo() %></title>
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include> <%
    if (posted) { %>
        <p class="errorMessage">
          Validation Error -- please check your entries and resubmit.
        </p> <%
    } %>
    <p class="pageInstructions">
      Modify the custom fields below and click the &quot;Submit&quot; button to
      record the changes.
    </p>
    <center>
      <form method="POST"> 
        <input type="hidden" name="sampleId" id="sampleId"
               value="<%=sampleId%>" />
        <input type="hidden" name="sampleHistoryId" id="sampleHistoryId"
               value="<%= sampleHistoryId %>" />
        <table cellpadding="5" cellspacing="2" width="800" class="formTable"><%
	  boolean displayedAField = false;
          while (pageHelper.moveNextLocalTrackingField(
                  LocalTrackingConfig.VISIBLE_ON_LOCALTRACKING)) {
	      displayedAField = true; %>
              <tr align="center">
		<th>
		  <%=pageHelper.getCurrentLocalTrackingFieldName()%>:
		</th>
		<td>
		  <input type="text" size="64" name="localTracking<%=
		         pageHelper.getCurrentLocalTrackingFieldTextType()%>"
		         value="<%= posted
		         ? HtmlHelper.nullToBlank(
		            request.getParameter("localTracking" +
                            pageHelper.getCurrentLocalTrackingFieldTextType()))
	                 : HtmlHelper.nullToBlank(
		            pageHelper.getNextAttributeValue(
	                    pageHelper.getCurrentLocalTrackingFieldTextType()))
		         %>" />
		</td>
	      </tr> <%
	  } %>
        </table> <%
	
        if (!displayedAField) {
	    // Special handling for when there are no localtracking fields...%>
	    <p class="errorMessage">
	      Sorry, no custom fields have been configured for this sample's
	      originating lab. &nbsp; Custom fields may be defined on a per-lab
	      basis by system administrators by inserting directives into
	      the recipnetd.conf file. &nbsp;  Please see the User Guide for
	      more information about the custom fields feature.
	    </p> <%
        } else {
	    // We already displayed some localtracking fields, so go ahead and
	    // display the rest of the form. %>
            <br />
            <br />
            <table cellpadding="5" cellspacing="2" border="2" width="840" 
                    class="formTable">
	      <tr>
		<th colspan="2">Comments about changes made:</th>
	      </tr>
	      <tr>
		<td colspan="2" align="center">
		  <textarea name="comments" id="comments" rows="10" cols="65"
                          wrap="hard"></textarea>
		</td>
	      </tr>
	    </table>&nbsp;<br />&nbsp;
	    <input type="submit" name="submit" id="submit" value="Submit" />
	    <input type="reset" value="Reset" /> <%
        } %>
      </form>
    </center>
  </body>
</html>
