<%--
  -- Reciprocal Net project
  -- modifytext.jsp
  --
  -- 28-Jul-2002: eisiorho wrote first draft
  -- 29-Aug-2002: leqian added localtracking support
  -- 05-Sep-2002: eisiorho modified the option menu to include new attributes
  -- 13-Sep-2002: jobollin fixed line delimiters (Task 433)
  -- 17-Oct-2002: ekoperda fixed bug #546 that sometimes prevented all
  --              localtracking attributes from appearing in the dropdown box
  --              at the top of the page, also reorganized page code
  -- 12-Nov-2002: eisiorho fixed bug #599
  -- 14-Nov-2002: eisiorho removed supporting code for Ltas for this page.
  --%>
<%@ page session="true" isThreadSafe="true"
         info="Modify Text"
         import="org.recipnet.site.wrapper.HtmlHelper"
         import="org.recipnet.site.container.SampleAnnotationInfo"
         import="org.recipnet.site.container.SampleAttributeInfo"
         import="org.recipnet.site.container.SampleTextInfo"
         import="org.recipnet.site.container.SampleDataInfo"
         import="org.recipnet.site.container.SampleInfo"
         import="org.recipnet.site.container.SampleHistoryInfo"
         import="org.recipnet.site.container.LocalTrackingConfig"
         import="java.util.Iterator"
         import="java.util.List" %>
<%@ include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>
<%!
    /**
     * This returns true if value is a valid Annotation/Attribute type. False
     * otherwise.
     */
    public boolean invalid_entry(int value) {
       if (SampleTextInfo.isAttribute(value)
               || SampleTextInfo.isAnnotation(value)) {
          return false;
       }
       return true;
    }
%>
<%
    if (!authController.checkUserAuthenticationStatus()) {
        request.setAttribute("reason",
                AuthenticationController.AUTHENTICATION_REQUIRED); %>
        <jsp:forward page="/login.jsp" />
<%  }

    int sampleId = SampleInfo.INVALID_SAMPLE_ID;
    String sampleIdStr = request.getParameter("sampleId");
    if (sampleIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleId = Integer.parseInt(sampleIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
        if ( !authController.canEditSample(sampleId) ) {
            request.setAttribute("reason",
                    AuthenticationController.INSUFFICIENT_ACCESS); %>
            <jsp:forward page="/login.jsp" />
<%      }
    }

    /*
     * If control reaches here then the user is authorized to edit the
     * sample specified in his request.
     */

    int sampleHistoryId = SampleHistoryInfo.INVALID_SAMPLE_HISTORY_ID;
    String sampleHistoryIdStr = request.getParameter("sampleHistoryId");
    if (sampleHistoryIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleHistoryId = Integer.parseInt(sampleHistoryIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
    }

    pageHelper.retrieveSingleSample(sampleId, sampleHistoryId);
    Iterator i;
    int boxId = 1;
    boolean error = false;
    boolean posted = false;
    String method = ((HttpServletRequest) request).getMethod();
    if ("POST".equals(method)) {
        posted = true;

        // boxId is used to figure out which form Modify/Delete button was
    	// pressed to change that particular form's field value. The variable
	    // boxId is received from the field called boxId.

        boxId = Integer.parseInt(request.getParameter("boxId"));
        String textTypeValue = "textTypeValue" + boxId;
        String textType = "textType" + boxId;
        String textIdNumber = "textIdNumber" + boxId;
        int postedTextType = -1;
        int postedTextIdNumber = -1;

        // Retrieve the form parameters
        try {
            postedTextType = Integer.parseInt(request.getParameter(textType));
            postedTextIdNumber =
                    Integer.parseInt(request.getParameter(textIdNumber));
        } catch (NumberFormatException ex) {
            // No need to handle this here because either postedTextType=-1 or
	        // postedTextIdNumber=-1 and we'll catch that later
        } catch (NullPointerException ex) {
            // No need to handle this here because either postedTextType=-1 or
            // postedTextIdNumber=-1 and we'll catch that later
        }
        // Verify that we received a valid request
        if (postedTextType == -1 || postedTextIdNumber == -1
                || invalid_entry(postedTextType) || boxId < 0) {
            /* Something is invalid; return an HTTP error */
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }

        // Handle the different kinds of form actions
        if ("Add".equals(request.getParameter("submit"))) {
            String value = request.getParameter(textTypeValue);
            if (value == null || "".equals(value)) {
                // Validation error; drop through
                error = true;
            } else {
                pageHelper.addTextInfo(sampleId, sampleHistoryId,
                        authController.getUserId(),
                        request.getRemoteAddr(),
                        postedTextType,
                        value,
                        SampleDataInfo.INVALID_INT_VALUE );
            }
        } else if ("Delete".equals(request.getParameter("submit"))) {
            pageHelper.deleteTextInfo(sampleId, sampleHistoryId,
                    authController.getUserId(),
                    request.getRemoteAddr(),
                    postedTextIdNumber,
                    postedTextType);
        } else if ("Modify".equals(request.getParameter("submit"))){
            String value = request.getParameter(textTypeValue);
            if (value == null || "".equals(value)) {
                // Validation error; drop through
                error = true;
            } else {
                pageHelper.modifySampleTextFields(sampleId, sampleHistoryId,
                        authController.getUserId(),
                        request.getRemoteAddr(),
                        postedTextIdNumber,
                        postedTextType,
                        value);
            }
        }

        // If no error occured and the add/modification/delete succeeded, the
        // client's browser needs to be informed of the newest sampleHistoryId.
        // The only way to do this is to issue a redirect.
        if (!error) {
            pageHelper.retrieveSingleSample(sampleId);
            ((HttpServletResponse) response).sendRedirect(
                    "modifytext.jsp?sampleId=" + sampleId
                    + "&sampleHistoryId=" + pageHelper.getSampleHistoryId());
            return;
        }
    } else if ( ! "GET".equals(method) ) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_METHOD_NOT_ALLOWED );
        return;
    }

    /*
     * If control reaches here then we have either a POST request with a
     * validation error or a GET request.
     */
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
  <link rel="stylesheet"
        href="../recipnet.css"
        type="text/css">
    <title>Reciprocal Net - <%= getServletInfo() %></title>
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
<%  if (posted && error) { %>
        <p class="errorMessage">
          Validation Error -- please check your entries and resubmit.
        </p>
<%  } %>
    <p class="pageInstructions">
      Click on a button to select an action, and fill out all the information
      in the form below and click the &quot;Submit&quot; button to record it.
    </p>
    <center>
      <form method="POST">
        <input type="hidden" name="sampleId" id="sampleId"
            value="<%=sampleId%>">
        <input type="hidden" name="sampleHistoryId" id="sampleHistoryId"
            value="<%= sampleHistoryId %>">
        <input type="hidden" name="boxId" id="boxId" value="0">
        <input type="hidden" name="textIdNumber0" id="textIdNumber0" value="0">
        <table cellpadding="5" cellspacing="2" width="800" class="formTable">
          <tr>
            <th colspan="3">Add Text for Sample</th>
          </tr>
          <tr>
            <th>Type of Field</th>
            <th>Field Value</th>
          </tr>
          <tr>
            <td align="center">
              <select name="textType0" id="textType0">
<%
    // Get a list of all the static text types, in alphabetical
    // order.  Emit an <option> element for every one of them.
    List textTypes = SampleTextInfo.getAllTextTypes();
    HtmlHelper.sortTextTypeList(textTypes);
    Iterator it = textTypes.iterator();
    while (it.hasNext()) {
        int textType = ((Integer) it.next()).intValue();
        out.println("<option value=\"" + textType + "\">"
              + HtmlHelper.textTypeStr(textType, null) + "</option>");
    }
%>
              </select>
            </td>
            <td align="center">
              <textarea type="text" name="textTypeValue0" id="textTypeValue0"
                        cols="36" rows="4" ></textarea>
            </td>
            <td>
              <input type="submit" value="Add" name="submit" id="submit">
            </td>
          </tr>
          <tr>
            <td colspan="5">&nbsp;<hr /></td>
          </tr>
        </table>
        <a href="sample.jsp?sampleId=<%= sampleId %>"
                >Back to the Sample page</a>
        <br />&nbsp;
        <br />&nbsp;
      </form>
      <table cellpadding="5" cellspacing="2" width="800" class="formTable">
        <tr>
          <th colspan="3">Modify/Delete Text for Sample</th>
        </tr>
        <tr>
          <th>Type of Field</th>
          <th>Field Value</th>
        </tr>
<%
    // Display a row in the table for every attribute that exists on the
    // current sample.
    String attributeStr = pageHelper.getNextAttributeValue(
                SampleTextInfo.INVALID_TYPE);
    while(attributeStr != null ) {
        String textTypeValue = "textTypeValue" + boxId;
        String textType = "textType" + boxId;
        String textIdNumber = "textIdNumber" + boxId;
        if (!pageHelper.isLocalTrackingFieldTextTypeValid(
                pageHelper.getCurrentAttributeType())) {
%>
        <form method="POST">
          <tr>
            <td>
              <b><%=pageHelper.getCurrentAttributeTypeStr() %></b>
              <input type="hidden" name="<%= textType %>" id="<%= textType %>"
                     value="<%= pageHelper.getCurrentAttributeType() %>"/>
              <input type="hidden" name="boxId" id="boxId"
                     value="<%= boxId %>" />
            </td>
            <td align="center">
              <input type="text" name="<%= textTypeValue %>" maxlength="128"
                     size="40" id="<%= textTypeValue %>"
                     value="<%= attributeStr %>" />
              <input type="hidden"  name="<%= textIdNumber %>"
                     id="<%= textIdNumber %>"
                     value="<%= pageHelper.getCurrentAttributeId() %>" />
            </td>
            <td>
              <input type="submit" name="submit" id="submit" value="Modify" />
            </td>
            <td>
              <input type="submit" name="submit" id="submit" value="Delete" />
            </td>
          </tr>
          <tr>
            <td colspan="5">&nbsp;<hr /></td>
          </tr>
        </form>
<%      }
        boxId++;
        attributeStr = pageHelper.getNextAttributeValue(
                SampleTextInfo.INVALID_TYPE);
    }
	// Display a row in the table for every annotation that exists on the
	// current sample.
    while(pageHelper.moveNextSampleAnnotation(SampleTextInfo.INVALID_TYPE)) {
        String textTypeValue = "textTypeValue" + boxId;
        String textType = "textType" + boxId;
        String textIdNumber = "textIdNumber" + boxId;
%>
        <form method="POST">
          <tr>
            <td>
              <b><%= pageHelper.getCurrentAnnotationTypeStr() %></b>
              <input type="hidden" name="<%= textType %>" id="<%= textType %>"
                     value="<%= pageHelper.getCurrentAnnotationType() %>"/>
              <input type="hidden" name="boxId" id="boxId"
                     value="<%= boxId %>" />
            </td>
            <td align="center">
              <textarea type="text" name="<%= textTypeValue %>"
                          id="<%= textTypeValue %>" cols="36" rows="4"
                          ><%= pageHelper.getAnnotationValue() %></textarea>
              <input type="hidden" name="<%= textIdNumber %>"
                          id="<%= textIdNumber %>"
                          value="<%= pageHelper.getCurrentAnnotationId() %>" />
            </td>
            <td>
              <input type="submit" name="submit" id="submit" value="Modify"/>
            </td>
            <td>
              <input type="submit" name="submit" id="submit" value="Delete"/>
            </td>
          </tr>
          <tr>
            <td colspan="5">&nbsp;<hr /></td>
          </tr>
        </form>
<%      boxId++;
    } %>
        <tr>
          <td colspan="3">
            <form method="POST">
              <a href="sample.jsp?sampleId=<%= sampleId %>"
                      >Back to the Sample page</a>
            </form>
          </td>
        </tr>
      </table>
    </center>
  </body>
</html>
