<%--
  -- Reciprocal Net project
  -- rawedit.jsp
  --
  -- 28-Jul-2002: eisiorho wrote first draft
  -- 06-Aug-2002: eisiorho fixed bug #274
  -- 09-Aug-2002: eisiorho fixed bug #324
  -- 13-Sep-2002: jobollin fixed line delimiters (Task 433)
  -- 18-Sep-2002: ekoperda fixed bug #461 by removing class SampleAtomInfo from
  --              the import list
  --%>
<%@ page session="true" isThreadSafe="true"
        info="Raw Edit of Sample"
        import="java.util.List"
        import="org.recipnet.site.wrapper.HtmlHelper"
        import="org.recipnet.site.container.SampleTextInfo"
        import="org.recipnet.site.container.SampleHistoryInfo"
        import="org.recipnet.site.container.SampleDataInfo"
        import="org.recipnet.site.container.SampleAttributeInfo"
        import="org.recipnet.site.container.SampleAccessInfo"
        import="org.recipnet.site.container.SampleAnnotationInfo"
        import="org.recipnet.site.container.SampleInfo" %>
<%@ include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>
<%
    if ( !authController.checkUserAuthenticationStatus() ) {
        request.setAttribute("reason",
                AuthenticationController.AUTHENTICATION_REQUIRED);
%>
<jsp:forward page="/login.jsp" />
<%
    }

    int sampleId = SampleInfo.INVALID_SAMPLE_ID;
    String sampleIdStr = request.getParameter("sampleId");
    if (sampleIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleId = Integer.parseInt(sampleIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
        if ( !authController.canEditSample(sampleId) ) {
            request.setAttribute("reason",
                    AuthenticationController.INSUFFICIENT_ACCESS);
%>
<jsp:forward page="/login.jsp" />
<%
        }
    }

    /*
     * If control reaches here then the user is authorized to edit the
     * sample specified in his request.
     */

    int sampleHistoryId = SampleHistoryInfo.INVALID_SAMPLE_HISTORY_ID;
    String sampleHistoryIdStr = request.getParameter("sampleHistoryId");
    if (sampleHistoryIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleHistoryId = Integer.parseInt(sampleHistoryIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
    }

    SampleInfo sample = pageHelper.getRawSampleInfo(sampleId, sampleHistoryId);

    boolean posted = false;
    String method = ((HttpServletRequest) request).getMethod();
    if ("POST".equals(method)) {
        posted = true;

        try {

            // Reconstructs the SampleDataInfo

            sample.dataInfo.a = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("a_dimen"));
            sample.dataInfo.b = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("b_dimen"));
            sample.dataInfo.c = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("c_dimen"));
            sample.dataInfo.alpha = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("alpha"));
            sample.dataInfo.beta = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("beta"));
            sample.dataInfo.gamma = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("gamma"));
            sample.dataInfo.z = HtmlHelper.validateOptionalInt(1, SampleDataInfo.INVALID_INT_VALUE, request.getParameter("z_molecules"));
            sample.dataInfo.sampleId = sample.id;
            sample.dataInfo.t = HtmlHelper.validateOptionalDouble(-273.0d, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("temp"));
            sample.dataInfo.rf = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("rf"));
            sample.dataInfo.rwf = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("rwf"));
            sample.dataInfo.rf2 = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("rf2"));
            sample.dataInfo.rwf2 = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("rwf2"));
            sample.dataInfo.goof = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("goof"));
            sample.dataInfo.v = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("volume"));
            sample.dataInfo.spgp = HtmlHelper.nullToBlank(request.getParameter("spgp"));
            sample.dataInfo.color = HtmlHelper.nullToBlank(request.getParameter("color"));
            sample.dataInfo.summary = HtmlHelper.nullToBlank(request.getParameter("summary"));
            sample.dataInfo.dcalc = HtmlHelper.validateOptionalDouble(0, SampleDataInfo.INVALID_DOUBLE_VALUE, request.getParameter("dcalc"));

            // Reconstructs the SampleInfo, based on the other Sample***Info objects.

            sample.id = sampleId;
            sample.labId = authController.getLabId();
            sample.status = pageHelper.getSampleStatus();
            sample.historyId = sampleHistoryId;
            sample.mostRecentHistoryId = sample.mostRecentHistoryId;

                pageHelper.saveRawSampleInfo(sample,
                                             authController.getUserId(),
                                             request.getRemoteAddr(),
                                             HtmlHelper.nullToBlank(request.getParameter("comments")) );

                ((HttpServletResponse) response).sendRedirect("sample.jsp?sampleId=" + pageHelper.getSampleId());
            } catch (NumberFormatException nfe) {
            }
    } else if ( ! "GET".equals(method) ) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_METHOD_NOT_ALLOWED );
        return;
    }
    /*
     * If control reaches here then we have either a POST request with a
     * validation error or a GET request. Can go on and receive info to
     * display.
     */
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
  <link rel="stylesheet"
        href="../recipnet.css"
        type="text/css">
    <title>Reciprocal Net - <%= getServletInfo() %></title>
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
<%  if (posted) { %>
    <p class="errorMessage">Validation Error -- please check your entries and
      resubmit</p>
<%  } %>
    <p class="pageInstructions">
      Enter the information on the form below and click the &quot;Submit&quot; button to record it.
    </p>
    <center>
      <form method="POST">
        <input type="hidden" name="sampleId" value="<%=sampleId%>">
        <table class="formTable" cellpadding="5" cellspacing="2">
          <tr>
            <th colspan="2">Sample Information</th>
          </tr>
          <tr>
            <td align="left" colspan="1">
              Local Lab's Name:&nbsp;<b><%= pageHelper.getSampleLabName() %></b>&nbsp;<br />
              Originating Provider's Name:&nbsp;<b><%= pageHelper.getSampleProviderName() %></b>&nbsp;<br />
            </td>
            <td align="left" colspan="1">
              Sample's Status:&nbsp;<b><%= HtmlHelper.statusStr(sample.status) %></b>&nbsp;<br />
              Version Number:&nbsp;<b><%= sampleHistoryId %></b>&nbsp;<br />
              Sample Number:&nbsp;<b><%= sample.localLabId %></b>
            </td>
          </tr>
        </table>&nbsp;<br />&nbsp;
<!---------------------------SampleDataInfo-------------------------------------------------->
        <table cellpadding="5" cellspacing="2" border="2" width="840" class="formTable">
          <tr>
            <th colspan="3">Sample Data Information</th>
          </tr>
          <tr>
            <th colspan="3">The Dimensions of the Sample's Cells</th>
          </tr>
          <tr>
            <th colspan="1">The 1st Dimension</th>
            <th colspan="1">The 2nd Dimension</th>
            <th colspan="1">The 3rd Dimension</th>
          </tr>
          <tr>
            <td colspan="1">
              <input type="text" name="a_dimen" id="a_dimen" size="21" maxlength="64"
                     value="<%= (posted) ? request.getParameter("a_dimen") : HtmlHelper.doubleToString(pageHelper.getSampleA(), 6) %>">
            </td>
            <td colspan="1">
              <input type="text" name="b_dimen" id="b_dimen" size="21" maxlength="64"
                     value="<%= (posted) ? request.getParameter("b_dimen") : HtmlHelper.doubleToString(pageHelper.getSampleB(), 6) %>">
            </td>
            <td colspan="1">
              <input type="text" name="c_dimen" id="c_dimen" size="21" maxlength="64"
                     value="<%= (posted) ? request.getParameter("c_dimen") : HtmlHelper.doubleToString(pageHelper.getSampleC(), 6) %>">
            </td>
          </tr>
          <tr>
            <th colspan="3">The Angle Between Measurement, in degrees</th>
          </tr>
          <tr>
            <th colspan="1">Alpha</th>
            <th colspan="1">Beta</th>
            <th colspan="1">Gamma</th>
          </tr>
          <tr>
            <td colspan="1">
              <input type="text" name="alpha" id="alpha" size="21" maxlength="64"
                     value="<%= (posted) ? request.getParameter("alpha") : HtmlHelper.doubleToString(pageHelper.getSampleAlpha(), 6) %>">
            </td>
            <td colspan="1">
              <input type="text" name="beta" id="beta" size="21" maxlength="64"
                     value="<%= (posted) ? request.getParameter("beta") : HtmlHelper.doubleToString(pageHelper.getSampleBeta(), 6) %>">
            </td>
            <td colspan="1">
              <input type="text" name="gamma" id="gamma" size="21" maxlength="64"
                     value="<%= (posted) ? request.getParameter("gamma") : HtmlHelper.doubleToString(pageHelper.getSampleGamma(), 6) %>">
            </td>
          </tr>
        </table>
        <table cellpadding="5" cellspacing="2" border="2" width="840" class="formTable">
          <tr>
            <th colspan="5">Agreement Indices</th>
          </tr>
          <tr>
            <th colspan="1">RF</th>
            <th colspan="1">RWF</th>
            <th colspan="1">R(F &#178;)</th>
            <th colspan="1">RW(F &#178;)</th>
            <th colspan="1">Goodness of Fit</th>
          </tr>
          <tr>
            <td colspan="1">
              <input type="text" name="rf" id="rf" size="15" maxlength="64"
                     value="<%= (posted) ? request.getParameter("rf") : HtmlHelper.doubleToString(pageHelper.getSampleRf(), 6) %>">
            </td>
            <td colspan="1">
              <input type="text" name="rwf" id="rwf" size="15" maxlength="64"
                     value="<%= (posted) ? request.getParameter("rwf") : HtmlHelper.doubleToString(pageHelper.getSampleRwf(), 6) %>">
            </td>
            <td colspan="1">
              <input type="text" name="rf2" id="rf2" size="15" maxlength="64"
                     value="<%= (posted) ? request.getParameter("rf2") : HtmlHelper.doubleToString(pageHelper.getSampleRf2(), 6) %>">
            </td>
            <td colspan="1">
              <input type="text" name="rwf2" id="rwf2" size="15" maxlength="64"
                     value="<%= (posted) ? request.getParameter("rwf2") : HtmlHelper.doubleToString(pageHelper.getSampleRwf2(), 6) %>">
            </td>
            <td colspan="1">
              <input type="text" name="goof" id="goof" size="15" maxlength="64"
                     value="<%= (posted) ? request.getParameter("goof") : HtmlHelper.doubleToString(pageHelper.getSampleGoof(), 6) %>">
            </td>
          <tr>
            <th colspan="2">Space Group</th>
            <th colspan="1">Temperature</th>
            <th colspan="2">Sample Color</th>
          </tr>
          <tr>
            <td colspan="2">
              <input type="text" name="spgp" id="spgp" size="32" maxlength="64"
                     value="<%= (posted) ? request.getParameter("spgp") : HtmlHelper.nullToBlank(pageHelper.getSampleSpaceGroup()) %>">
            </td>
            <td colspan="1">
              <input type="text" name="temp" id="temp" size="18" maxlength="64"
                     value="<%= (posted) ? request.getParameter("temp") : HtmlHelper.doubleToString(pageHelper.getSampleT(), 6) %>">
            </td>
            <td colspan="2">
              <input type="text" name="color" id="color" size="32" maxlength="64"
                     value="<%= (posted) ? request.getParameter("color") : HtmlHelper.nullToBlank(pageHelper.getSampleColor()) %>">
            </td>
          </tr>
        </table>
        <table cellpadding="5" cellspacing="2" border="2" width="840" class="formTable">
          <tr>
            <th colspan="2">Calculated Density</th>
            <th colspan="2">Summary</th>
          </tr>
          <tr>
            <td colspan="2">
              <input type="text" name="dcalc" id="dcalc" size="32" maxlength="64"
                     value="<%= (posted) ? request.getParameter("dcalc") : HtmlHelper.doubleToString(pageHelper.getSampleCalculatedDensity(), 6) %>">
            </td>
            <td colspan="2" align="center" rowspan="5">
              <textarea name="summary" id="summary" rows="10"
                        cols="32" wrap="hard"><%= (posted) ?  request.getParameter("summary") : HtmlHelper.nullToBlank(pageHelper.getSampleSummary()) %></textarea>
            </td>
          </tr>
          <tr>
            <th colspan="2"># of Molecules (in unit cells)</th>
          </tr>
          <tr>
            <td colspan="2">
              <input type="text" name="z_molecules" id="z_molecules" size="18" maxlength="32"
                     value="<%= (posted) ? request.getParameter("z_molecules") : HtmlHelper.intToString(pageHelper.getSampleZ()) %>">
            </td>
          </tr>
          <tr>
            <th colspan="2">Volume of Sample</th>
          </tr>
          <tr>
            <td colspan="2">
              <input type="text" name="volume" id="volume" size="18" maxlength="64"
                     value="<%= (posted) ? request.getParameter("volume") : HtmlHelper.doubleToString(pageHelper.getSampleV(), 6) %>">
            </td>
          </tr>
        </table>&nbsp;<br />&nbsp;
<!---------------------------Comments-------------------------------------------------------->
        <table cellpadding="5" cellspacing="2" border="2" width="840" class="formTable">
          <tr>
            <th colspan="2">Lab User Comments About Changes Made in Raw Edit</th>
          </tr>
          <tr>
            <td colspan="2" align="center">
              <textarea name="comments" id="comments" rows="10"
                        cols="65" wrap="hard"></textarea>
            </td>
          </tr>
        </table>&nbsp;<br />&nbsp;
        <input type="submit" name="submit" id="submit" value="Submit">
        <input type="reset" value="Reset">
      </form>
    </center>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
