<%--
  -- Reciprocal Net project
  -- releasetopublic.jsp
  --
  -- 26-Jul-2002: eisiorho wrote first draft
  -- 07-Aug-2002: eisiorho fixed bug #325
  -- 14-Aug-2002: eisiorho fixed bug #344
  -- 29-Aug-2002: leqian added localtracking support
  -- 13-Sep-2002: jobollin fixed line delimiters (Task 433)
  --%>
<%@ page session="true" isThreadSafe="true"
        info="Release Sample to Public"
        import="org.recipnet.site.wrapper.HtmlHelper"
        import="org.recipnet.site.container.SampleDataInfo"
        import="org.recipnet.site.container.LocalTrackingConfig"
        import="org.recipnet.site.container.LabInfo"
        import="org.recipnet.site.container.SampleInfo"
        import="org.recipnet.site.container.SampleHistoryInfo" %>
<%@ include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>
<%
    if ( !authController.checkUserAuthenticationStatus() ) {
        request.setAttribute("reason",
                AuthenticationController.AUTHENTICATION_REQUIRED);
%>
<jsp:forward page="/login.jsp" />
<%
    }

    int sampleId = SampleInfo.INVALID_SAMPLE_ID;
    String sampleIdStr = request.getParameter("sampleId");
    if (sampleIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleId = Integer.parseInt(sampleIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
        if ( !authController.canEditSample(sampleId) ) {
            request.setAttribute("reason",
                    AuthenticationController.INSUFFICIENT_ACCESS);
%>
<jsp:forward page="/login.jsp" />
<%
        }
    }

    /*
     * If control reaches here then the user is authorized to edit the
     * sample specified in his request.
     */

    int sampleHistoryId = SampleHistoryInfo.INVALID_SAMPLE_HISTORY_ID;
    String sampleHistoryIdStr = request.getParameter("sampleHistoryId");
    if (sampleHistoryIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleHistoryId = Integer.parseInt(sampleHistoryIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
    }

    pageHelper.retrieveSingleSample(sampleId, sampleHistoryId);
	pageHelper.retrieveLocalTrackingConfig();

    boolean posted = false;
    String method = ((HttpServletRequest) request).getMethod();
    if ("POST".equals(method)) {
        posted = true;

		String fieldValue;
		int fieldType;
		while (pageHelper.moveNextLocalTrackingField(LocalTrackingConfig.VISIBLE_ON_RELEASE_TO_PUBLIC)) {
                    fieldType=pageHelper.getCurrentLocalTrackingFieldTextType();
                    fieldValue= request.getParameter("localTracking"+fieldType);
                    if (null==fieldValue || fieldValue.trim().equals("")) 
	                pageHelper.modifyLtaDuringNextAction(fieldType, null);					
                    else
		        pageHelper.modifyLtaDuringNextAction(fieldType, fieldValue);				
		}			

        pageHelper.releaseSampleToPublic(sampleId, sampleHistoryId,
                               authController.getUserId(),
                               request.getRemoteAddr(),
                               HtmlHelper.nullToBlank(request.getParameter("copyright")),
                               HtmlHelper.nullToBlank(request.getParameter("layman")),
                               HtmlHelper.nullToBlank(request.getParameter("comments")) );

        ((HttpServletResponse) response).sendRedirect("sample.jsp?sampleId=" + pageHelper.getSampleId());
    } else if ( ! "GET".equals(method) ) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_METHOD_NOT_ALLOWED );
                return;
    }

    /*
     * If control reaches here then we have either a POST request with a
     * validation error or a GET request. Can go on and receive info to
     * display.
     */
	 pageHelper.retrieveLocalTrackingConfig();
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
  <link rel="stylesheet"
        href="../recipnet.css"
        type="text/css">
    <title>Reciprocal Net - <%= getServletInfo() %></title>
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
<%  if (posted) { %>
    <p class="errorMessage">Validation Error -- please check your entries and
      resubmit</p>
<%  } %>
    <p class="pageInstructions">
      Enter the comments, edit the copyright, and write in
      layman's term what this chemical is on the form below and
      click the &quot;Submit&quot; button to record it.
    </p>
    <center>
    <table class="formTable" cellpadding="5" cellspacing="2" border="2" width="600">
      <tr>
        <th colspan="4">Information about the Sample</th>
      </tr>
      <tr>
        <th>Sample Number</th>
        <th>Originating Lab</th>
        <th>Originating Provider</th>
      </tr>
      <tr>
        <td><b><%= pageHelper.getSampleLocalLabId() %></b></td>
        <td><b><%= pageHelper.getSampleLabName() %></b></td>
        <td><b><%= pageHelper.getSampleProviderName() %></b></td>
      </tr>
    </table>
    <form method="POST">
      <input type="hidden" name="sampleId" value="<%=sampleId%>">
      <table class="formTable" cellpadding="5" cellspacing="2" border="2" width="600">
        <tr>
          <th>Copyright Notice (Optional):<br />
            <i>Describe how your lab wants to handle the legal aspects concerning the use<br />
               and publication of this sample.
            </i>
          </th>
        </tr>
        <tr>
          <td>
            <textarea name="copyright" id="copyright" rows="12" cols="65" 
            wrap="hard"><%= posted ? request.getParameter("copyright") : pageHelper.getSampleLabDefaultCopyrightNotice() %></textarea>
          </td>
        </tr>
        <tr>
          <td>&nbsp;</td>
        </tr>
        <tr>
          <th>Layman Explanation (Optional):<br />
            <i>What are the interesting aspects of the sample? (in Plain English)</i>
          </th>
        </tr>
        <tr>
          <td>
            <textarea name="layman" id="layman" rows="12"
                      cols="65" wrap="hard"><%= HtmlHelper.nullToBlank(request.getParameter("layman")) %></textarea>
        </tr>
        <tr>
          <td>&nbsp;</td>
        </tr>
		<%
		while (pageHelper.moveNextLocalTrackingField(LocalTrackingConfig.VISIBLE_ON_RELEASE_TO_PUBLIC)) {
		%>
		<tr>
			<th>
			<%=pageHelper.getCurrentLocalTrackingFieldName()%>:
			</th>
			</tr><tr>		
			<td>
			<% int ltType=pageHelper.getCurrentLocalTrackingFieldTextType(); %>
			<input type="text" name="localTracking<%=ltType%>" 
				size="64" value="<%=posted?HtmlHelper.nullToBlank(
					request.getParameter("localTracking"+ltType)):
					HtmlHelper.nullToBlank(pageHelper.getNextAttributeValue(ltType))%>">
			</td>
		</tr>
		<% 
		}
		%>
        <tr>
          <th>Comments (Optional):<br />
            <i>Edit the Comments associated with the Sample.</i>
          </th>
        </tr>
        <tr>
          </td>
          <td>
            <textarea name="comments" id="comments" rows="12"
                      cols="65" wrap="hard"><%= HtmlHelper.nullToBlank(request.getParameter("comments")) %></textarea>
          </td>
        </tr>
      </table>
      <input type="submit" value="Submit">
      <input type="reset" value="Reset">
    </form>
    </center>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
