<%--
 * Reciprocal Net project
 * @(#)lab/sample.jsp
 *
 * 11-Jul-2002: leqian wrote first draft
 * 12-Aug-2002: leqian and ekoperda fixed bug #283 by allowing the user to
 *              create a repository directory if one does not already exist.
 * 14-Aug-2002: leqian changed UI #347
 * 19-Aug-2002: eisiorho added empirical/Structural formula, task #284
 * 28-Aug-2002: leqian added displayOneItem functions and added displaying
 *              local tracking ability. Task #391, #401
 * 10-Sep-2002: eisiorho added appropriate measurement unit for "scientific
 *              data"
 * 18-Sep-2002: ekoperda fixed bug #462 (correct symbol for Angstroms)
 * 19-Sep-2002: eisiorho fixed bug #443 (render correctly in Netscape 4.7)
 * 15-Oct-2002: eisiorho updated workflow links to be visible only if
 *              PageHelper.isActionValid() returns true.
 * 07-Nov-2002: eisiorho added localtracking.jsp as a link
 * 19-Dec-2002: eisiorho added logic so that if there is no available .crt
 *              file, no applet will try to load.
 *
 * If the attribute "sampleId" is set, this page will show the sample with
 * this sample Id.
 * If it is not set, this page will show the current sample in pageHelper.
--%>
<%@page session="true" isThreadSafe="true"
    info="Edit sample"
    import="org.recipnet.site.wrapper.HtmlHelper"
	import="org.recipnet.site.container.SampleDataInfo"
	import="org.recipnet.site.container.SampleInfo"
	import="java.rmi.RemoteException"
	import="org.recipnet.site.container.SampleTextInfo"
	import="org.recipnet.site.container.RepositoryFile"
    import="org.recipnet.site.container.SampleAttributeInfo"
	import="java.util.List"
	import="org.recipnet.site.container.RepositoryDirectory"
	import="java.util.Iterator"
	import="org.recipnet.site.container.SampleHistoryInfo" %>
<%!
    // This function return an HTML formated string which display the value
    // dvalue in a table. If the last parameter indicate the default message
    // to be displayed if there is no value for dvalue.
    String displayOneItem(String title, double dvalue, int decimalSize,
            String defaultMsg) {
	return "<tr> <th class=\"twoColumnLeft\">" + title
	        + "</th> <td class=\"twoColumnRight\">"
                + ((0==Double.compare(dvalue,
                            SampleDataInfo.INVALID_DOUBLE_VALUE))
                  ? defaultMsg : HtmlHelper.doubleToString(dvalue,decimalSize))
                + "</td> </tr>";
    }

    // This function return an HTML formated string which display the value
    // dvalue in a table. If the dvalue is invalid, display nothing.
    String displayOneItem(String title, double dvalue, int decimalSize) {
        if (0==Double.compare(dvalue, SampleDataInfo.INVALID_DOUBLE_VALUE)) {
	    return "";
        }
	return "<tr> <th class=\"twoColumnLeft\">" + title
            + "</th> <td class=\"twoColumnRight\">"
            + HtmlHelper.doubleToString(dvalue,decimalSize)
            + "</td> </tr>";
    }

    // This function return an HTML formated string which display the value
    // ivalue in a table. If the ivalue is invalid, display the defaultMsg
    String displayOneItem(String title, int ivalue, String defaultMsg) {
        return "<tr> <th class=\"twoColumnLeft\">" + title
                + "</th> <td class=\"twoColumnRight\">"
		+ ((ivalue==SampleDataInfo.INVALID_INT_VALUE)
                    ? defaultMsg : Integer.toString(ivalue))
                + "</td> </tr>";
    }

    // This function return an HTML formated string which display the value
    // ivalue in a table.
    String displayOneItem(String title, int ivalue) {
	if (ivalue==SampleDataInfo.INVALID_INT_VALUE) {
	    return "";
        }
	return "<tr> <th class=\"twoColumnLeft\">" + title
                + "</th> <td class=\"twoColumnRight\">" + ivalue
                + "</td> </tr>";
    }

    // This function return an HTML formated string which display the value
    // ivalue in a table. If the svalue is empty, display defaultMsg.
    String displayOneItem(String title, String svalue, String defaultMsg) {
	return "<tr> <th class=\"twoColumnLeft\">" + title
                + "</th> <td class=\"twoColumnRight\">"
                + ((null==svalue || svalue.equals(""))
                    ? defaultMsg : svalue)
                + "</td> </tr>";
    }

    // This function return an HTML formated string which display the value
    // ivalue in a table. If the svalue is empty, display nothing.
    String displayOneItem(String title, String svalue) {
	if (null==svalue || svalue.equals("")) {
	    return "";
        }
	return "<tr> <th class=\"twoColumnLeft\">" + title
                + "</th> <td class=\"twoColumnRight\">"
                + svalue + "</td> </tr>";
    }

    // For integers to be displayed and their scientific units.
    String displayOneItem(String title, int ivalue, String defaultMsg,
            String extra){
	return "<tr> <th class=\"twoColumnLeft\">" + title
                + "</th> <td class=\"twoColumnRight\">"
                + ((ivalue==SampleDataInfo.INVALID_INT_VALUE)
                   ? defaultMsg : Integer.toString(ivalue))
                + extra + "</td> </tr>";
    }

    // For doubles to be displayed and their scientific units.
    // Use object to overload between displayOneItem methods.
    String displayOneItem(String title, double dvalue, int decimalSize,
            String extra, Object dummy){
	if (0==Double.compare(dvalue, SampleDataInfo.INVALID_DOUBLE_VALUE)) {
	    return "";
        }
	return "<tr> <th class=\"twoColumnLeft\">" + title
                + "</th> <td class=\"twoColumnRight\">"
                + HtmlHelper.doubleToString(dvalue,decimalSize)+ extra
                + "</td> </tr>";
    }
%>

<%-- Include the common session definitions. --%>
<%@ include file="/WEB-INF/common.inc" %>
<%
    int i, j;

    // message shown when a sample data item is missing
    String defaultMsg="(not entered)";

    // number of columns to be displayed in the section of the page that lists
    // repository files.
    int numDisplayRepositoryFilesCols = 8;

    // number of columns to be displayed in menu of workflow actions
    int numDisplayMenuCols = 6;

    // obtain query-line parameters
    String sampleIdStr = request.getParameter("sampleId");
    int sampleId=SampleInfo.INVALID_SAMPLE_ID;
    String sampleHistoryIdStr = request.getParameter("sampleHistoryId");
    int sampleHistoryId=SampleHistoryInfo.INVALID_SAMPLE_HISTORY_ID;
    String method=request.getMethod();
    String action=request.getParameter("action");
    try {
	    sampleId=Integer.parseInt(sampleIdStr);
    } catch (NumberFormatException ex) {
	    response.sendError(response.SC_BAD_REQUEST);
	    return;
    }

    // ensure the user is authorized to edit this sample
    if (!authController.checkUserAuthenticationStatus()) {
        request.setAttribute("reason",
                authController.AUTHENTICATION_REQUIRED); %>
        <jsp:forward page="/login.jsp" />
<%  }
    if (!authController.canEditSample(sampleId)) {
        request.setAttribute("reason", authController.INSUFFICIENT_ACCESS); %>
        <jsp:forward page="/login.jsp" />
<%  }

    // figure out which version of the sample to display.  Tell PageHelper to
    // retrieve the necessary containers from the core.
    if (sampleHistoryIdStr != null) {
	    try {
	        sampleHistoryId=Integer.parseInt(sampleHistoryIdStr);
	    } catch (NumberFormatException ex) {
	        response.sendError(response.SC_BAD_REQUEST);
	        return;
    	}
    	pageHelper.retrieveSingleSample(sampleId, sampleHistoryId);
    } else {
	    pageHelper.retrieveSingleSample(sampleId);
    }
    pageHelper.retrieveRepositoryDir(sampleId);
	pageHelper.retrieveLocalTrackingConfig();

    // Special handling if the user commanded this page to create a repository
    // directory (during a post-back).
    if ("POST".equals(method) && "Create".equals(action)) {
    	String dirName = request.getParameter("dirName");
	    if ("".equals(dirName)) {
	        dirName = null;
        }

    	pageHelper.createDataDirectory(dirName);

	    // Adding a dummy parameter to the query line is necessary to make
	    // Netscape accept the redirect to an otherwise-identical URL.
    	response.sendRedirect("sample.jsp?sampleId=" + sampleId + "&dummy=0");
	    return;
    }

	double displayDouble=SampleDataInfo.INVALID_DOUBLE_VALUE;
	int displayInt=SampleDataInfo.INVALID_INT_VALUE;
    // Get information from PageHelper about the repository directory
    // associated with this sample.
    int ticket=0;
    int repositoryDirStatus = pageHelper.getRepositoryDirStatus();
    boolean repositoryValid =
             (repositoryDirStatus == RepositoryDirectory.DATADIR_OK)
             || (repositoryDirStatus ==RepositoryDirectory.DATADIR_NOT_NEEDED);
    if (repositoryValid) {
 	   ticket=pageHelper.grantNewTicket();
    }

    // Set lots of local variables that will determine how this page gets
    // rendered.
    int status = pageHelper.getSampleStatus();
	String empirical = pageHelper.getNextAttributeValue(
	        SampleAttributeInfo.EMPIRICAL_FORMULA);
	String structural = pageHelper.getNextAttributeValue(
	        SampleAttributeInfo.STRUCTURAL_FORMULA);
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Reciprocal Net - <%=getServletInfo() %> </title>
    <link href="../recipnet.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <jsp:include page="/header.jsp">
      <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
    <br/>
    <table width="100%">
      <tr valign="top">
        <td>
	      <table>
	    <%=displayOneItem("Sample number:",
                       pageHelper.getSampleLocalLabId(),"")%>
        <%=displayOneItem("Lab name:",
                       pageHelper.getSampleLabName(),"")%>
        <%=displayOneItem("Provider name:",
                       pageHelper.getSampleProviderName(),"")%><%
	if (structural != null) { %>
        <%=displayOneItem("Structural formula:",
		      HtmlHelper.prettyHtmlChemicalFormula(structural), "")%><%
    }
	if (empirical != null) { %>
        <%=displayOneItem("Empirical formula:",
		       HtmlHelper.prettyHtmlChemicalFormula(empirical), "")%><%
    }%>
	      </table>
<%  if (repositoryValid && pageHelper.getUrlForCrtFile(ticket) != null) { %>
	      <applet code="org.recipnet.site.jamm.minijamm.miniJaMM.class"
              codebase="../applets/jamm/" archive="miniJaMM.jar"
	          width=400 height=400>
	        <param name="background" value="eeeeee" />
	        <param name="textcolor" value="000000" />
	        <param name="border" value="true" />
	        <param name="model" value="<%= pageHelper.getUrlForCrtFile(
	                                               ticket) %>" />
	      </applet>
	      <br />
          <br />
	      <a href="../jamm.jsp?sampleId=<%=sampleId%>"
                     >More visualization options</a>
          <br />
<%	} %>
        </td>
	    <td>
	      <table>
		<%=displayOneItem("a:", pageHelper.getSampleA(), 4, " &#197;", null)%>
		<%=displayOneItem("b:", pageHelper.getSampleB(), 4, " &#197;", null)%>
		<%=displayOneItem("c:", pageHelper.getSampleC(), 4, " &#197;", null)%>
		<%=displayOneItem("alpha:", pageHelper.getSampleAlpha(), 2,
                           "&#176;", null)%>
		<%=displayOneItem("beta:", pageHelper.getSampleBeta(), 2,
                           "&#176;", null)%>
		<%=displayOneItem("gamma:", pageHelper.getSampleGamma(), 2,
                           "&#176;", null)%>
		<%=displayOneItem("space group:", pageHelper.getSampleSpaceGroup())%>
		<%=displayOneItem("calculated density:",
		           pageHelper.getSampleCalculatedDensity(), 3,
		           " g/cm<sup>3</sup>", null)%>
		<%=displayOneItem("color:", pageHelper.getSampleColor())%>
		<%=displayOneItem("z:", pageHelper.getSampleZ())%>
		<%=displayOneItem("temperature:", pageHelper.getSampleT(), 1,
                           "&#176; C", null)%>
		<%=displayOneItem("volume:", pageHelper.getSampleV(), 3,
	                   " &#197;<sup>3</sup>", null)%>
		<%=displayOneItem("R(F):", pageHelper.getSampleRf(),3)%>
		<%=displayOneItem("R<sub>w</sub>(F):", pageHelper.getSampleRwf(),3)%>
		<%=displayOneItem("R(F<sup>2</sup>):", pageHelper.getSampleRf2(),3)%>
		<%=displayOneItem("R<sub>w</sub>(F<sup>2</sup>):",
		           pageHelper.getSampleRwf2(),3)%>
		<%=displayOneItem("Formula Weight:",
                           pageHelper.getFormulaWeight(), 4, " g/mole", null)%>
		<%=displayOneItem("goodness of fit:", pageHelper.getSampleGoof(),3)%>
		<%=displayOneItem("Summary:", pageHelper.getSampleSummary())%>
<%
	String attributeStr;
	int attributeInt;
	while (null != (attributeStr =pageHelper.getNextAttributeValue(
                    SampleTextInfo.INVALID_TYPE))) {
        // Since Empirical and structural foumlas are displayed in
        // left column already, we do not display them here.
        if (SampleAttributeInfo.EMPIRICAL_FORMULA != (attributeInt
                   = pageHelper.getCurrentAttributeType())
                   && (SampleAttributeInfo.STRUCTURAL_FORMULA != attributeInt)){
            out.println(displayOneItem(pageHelper.getCurrentAttributeTypeStr()
                    + ":", attributeStr));
        }
	}
	while(pageHelper.moveNextSampleAnnotation(SampleTextInfo.INVALID_TYPE)) {
        out.println(displayOneItem(
                pageHelper.getCurrentAnnotationTypeStr() + ":",
                pageHelper.getAnnotationValue()));
	} %>
	      </table>
	    </td>
	  </tr>
	</table>
	<br />
	<hr />
<%  if (repositoryValid) { %>
	Repository Files:
	<br />
    <table width="100%">
      <tr>
<%
	    String repositoryDirBaseUrl;
	    Iterator iterator = pageHelper.getRepositoryDirFiles().iterator();
	    repositoryDirBaseUrl=pageHelper.getRepositoryDirUrl();
	    j = 0;
	    while (iterator.hasNext()) {
	        String fileName = ((RepositoryFile) iterator.next()).name;
		    if (j == numDisplayRepositoryFilesCols) {
		        j=0; %>
      </tr>
      <tr>
<% 	        } %>
	    <td>
		  <a href="<%= repositoryDirBaseUrl%><%=fileName
                            %>?ticket=<%=ticket%>"><%=fileName %></a>
        </td>
<% 	        j++;
	    }
	    for (i=j; i<numDisplayRepositoryFilesCols; i++) { %>
	    <td></td>
<%      } %>
	  </tr>
    </table>
<%
    } else {
        // Special handling if no repository directory exists yet.  Display
        //   an alternate UI that will let the user create the directory.%>
    <font color="red" size="+1">
 	    No files for <%=pageHelper.getSampleLocalLabId()%> in repository!
      <br /><%
	    if (sampleHistoryIdStr==null && status!=SampleInfo.WITHDRAWN) {
	        switch (repositoryDirStatus) {
	          case RepositoryDirectory.INVALID_STATUS:
                  out.println("Invalid status");
		          break;
	          case RepositoryDirectory.DATADIR_MISSING_AND_NO_HOLDING_RECORD:
		          out.println("Data directory missing and no holding record");
		          break;
	          case RepositoryDirectory.DATADIR_FOUND_BUT_NO_HOLDING_RECORD:
        	      out.println("Data directory found but no holding record");
		          break;
	          case RepositoryDirectory.DATADIR_MISSING:
		          out.println("Data directory missing");
		          break;
	          case RepositoryDirectory.DATADIR_MOVED:
		          out.println("Data directory moved");
		          break;
	    } %>
    </font>
	<form method="post">
       You should create a directory in the repository to store this
       sample's data files.  Please specify the directory to be
       created below.  You may leave the text box blank if you wish
       to have the data directory created in the default location.
       <p />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
	   <%=pageHelper.getRepositoryDirPrefix()%>
	   <input name="dirName" type="text" size="40" />/<%=
             pageHelper.getSampleLocalLabId()%>/&nbsp;&nbsp;&nbsp;&nbsp;<br />
       <center>
	     <input name="action" type="submit" value="Create" />
       </center>
	   <input name="sampleId" type="hidden" value="<%=sampleId%>" />
	</form>
<%
        } else {
  	        out.println("</font>");
	    }
    } %>

	<hr />
<%   if (sampleHistoryIdStr==null) { %>
	    <%-- Links --%>
	<table width="100%" align="center" class="menu">
<%
        for (i = 0; i < 12; i++) {
            if (i % numDisplayMenuCols == 0) { %>
      <tr>
<%          } %>
        <td>
		  <%= HtmlHelper.menuSpace(HtmlHelper.MENU) %>
<%
            int historyId=pageHelper.getSampleHistoryId();
            switch (i) {
		    case 0:
        	      out.println(HtmlHelper.menuItem(HtmlHelper.MENU,
                          "Sample Detail",
                          "../showsample.jsp?sampleId=" + sampleId, true));
                  break;
		    case 1:
        	      out.println(HtmlHelper.menuItem(HtmlHelper.MENU,
                          "Sample History",
        	              "samplehistory.jsp?sampleId=" + sampleId, true));
                  break;
		    case 2:
	              out.println(HtmlHelper.menuItem(HtmlHelper.MENU,
                          "Raw Edit",
                          "rawedit.jsp?sampleId=" + sampleId
                            + "&sampleHistoryId=" + historyId,
	                      pageHelper.isActionValid(
                                      SampleHistoryInfo.RAW_EDITED)));
                  break;
		    case 3:
	              out.println(HtmlHelper.menuItem(HtmlHelper.MENU,
                          "Withdraw",
                          "withdraw.jsp?sampleId=" + sampleId
	                        + "&sampleHistoryId=" + historyId,
	                      pageHelper.isActionValid(
                                      SampleHistoryInfo.WITHDRAWN)));
                  break;
		    case 4:
	              out.println(HtmlHelper.menuItem(HtmlHelper.MENU,
                          "Change ACL",
                          "changeacl.jsp?sampleId=" + sampleId
                            + "&sampleHistoryId=" + historyId,
	                      pageHelper.isActionValid(
                                      SampleHistoryInfo.CHANGED_ACL)));
                  break;
		    case 5:
	              out.println(HtmlHelper.menuItem(HtmlHelper.MENU,
                          "Add Citation",
                          "addcitation.jsp?sampleId=" + sampleId
	                        + "&sampleHistoryId=" + historyId
                            + "&addcitation_action=Citation",
                          pageHelper.isActionValid(
                                  SampleHistoryInfo.CITATION_ADDED)));
                  break;
		    case 6:
	              out.println(HtmlHelper.menuItem(HtmlHelper.MENU,
                          "Modify Text",
                          "modifytext.jsp?sampleId=" + sampleId
	                        + "&sampleHistoryId=" + historyId,
                          pageHelper.isActionValid(
                                  SampleHistoryInfo.MODIFIED_TEXT_FIELDS)));
                  break;
            case 7:
	              out.println(HtmlHelper.menuItem(HtmlHelper.MENU,
                          "Gather Data",
                          "gatherdata.jsp?sampleId=" + sampleId
                            + "&sampleHistoryId=" + historyId,
                          pageHelper.isActionValid(
                                  SampleHistoryInfo.DATA_GATHERED)));
                  break;
            case 8:
	              out.println(HtmlHelper.menuItem(HtmlHelper.MENU, "Solve",
	                      "solve.jsp?sampleId=" + sampleId
                          + "&sampleHistoryId="+historyId,
                          pageHelper.isActionValid(SampleHistoryInfo.SOLVED)));
                  break;
            case 9:
	              out.println(HtmlHelper.menuItem(HtmlHelper.MENU,
	                      "Release to Public",
                          "releasetopublic.jsp?sampleId=" + sampleId
                          + "&sampleHistoryId=" + historyId,
                          pageHelper.isActionValid(
	                              SampleHistoryInfo.MADE_VISIBLE_TO_PUBLIC)));
                  break;
		    case 10:
	              out.println(HtmlHelper.menuItem(HtmlHelper.MENU,
                          "Stall",
                          "stall.jsp?sampleId=" + sampleId
                            + "&sampleHistoryId=" + historyId,
                          pageHelper.isActionValid(SampleHistoryInfo.STALLED)));
                  break;
		    case 11:
	              out.println(HtmlHelper.menuItem(HtmlHelper.MENU,
                          "Custom fields",
                          "localtracking.jsp?sampleId=" + sampleId
                            + "&sampleHistoryId=" + historyId,
                          pageHelper.isActionValid(
                                  SampleHistoryInfo.MODIFIED_TEXT_FIELDS)));
                  break;
		    }
    		out.println("</td>");
	    	if ((i+1) % numDisplayMenuCols == 0) {
		    	out.println("</tr>");
	    	}
        }
        i = i % numDisplayMenuCols;
        if (i > 0) {
            for (j = i; j < numDisplayMenuCols; j ++) { %>
                    <td></td>
<%          } %>
		</tr>
<%      } %>
	  </table>
<%  } else { %>
  	  <a href="../showsample.jsp?sampleId=<%=sampleId%>&sampleHistoryId=<%=
                  sampleHistoryId%>">show sample page</a>
<%  } %>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
