<%--
 * Reciprocal Net project
 * @(#)lab/samplehistory.jsp
 *
 * 11-Jul-2002: leqian wrote first draft
 * 07-Aug-2002: ekoperda accommodated bug #288 by changing all references
 *              to fullSample.status to fullSample.mostRecentStatus.
 * 12-Aug-2002: leqian fixed bug #328, add pageTitle parameter.
 * 13-Sep-2002: jobollin fixed line delimiters (Task 433)
 *
 * This is one of the workflow action pages.  It
 * shows the information of a sample.
--%>

<%--
    The session="true" and isThreadSafe="true" attributes of the page
    directive are the default values; they simply serve as reminders,
    and as place holders should the defaults need to be overriden.  A
    specific error page could also be specified here; because it is not,
    any specified in this application's web.xml file will be used as a default
--%>
<%@page session="true" isThreadSafe="true"
        info="Sample History" 
        import="org.recipnet.site.wrapper.HtmlHelper,org.recipnet.site.container.SampleDataInfo,
				org.recipnet.site.container.SampleInfo,java.util.List,org.recipnet.site.container.FullSampleInfo,
				org.recipnet.site.container.SampleHistoryInfo,java.util.Date,java.text.DateFormat,
				java.util.Locale, java.util.Iterator" %> 
				
<%--
	Include the common session definitions.
--%>
<%@ include file="/WEB-INF/common.inc" %>

<% 
	String sampleIdStr = request.getParameter("sampleId");
	String revertSampleHistoryIdStr = request.getParameter("revertSampleHistoryId");
	String action=request.getParameter("action");
	DateFormat dateFormat=DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.SHORT, Locale.US);
	int sampleId=SampleInfo.INVALID_SAMPLE_ID;
	int revertSampleHistoryId=SampleHistoryInfo.INVALID_SAMPLE_HISTORY_ID;
	try{
		sampleId=Integer.parseInt(sampleIdStr);
	} catch (NumberFormatException ex) {
		response.sendError(response.SC_BAD_REQUEST);
		return;
	}
 
	if (!authController.checkUserAuthenticationStatus()) {
        request.setAttribute("reason", authController.AUTHENTICATION_REQUIRED);
		%>
			<jsp:forward page="/login.jsp" /> 		
		<%
	}
	if (!authController.canEditSample(sampleId)) {
        request.setAttribute("reason", authController.INSUFFICIENT_ACCESS);
		%>
			<jsp:forward page="/login.jsp" /> 		
		<%
	}
	
	if (!"POST".equals(request.getMethod()) && !"GET".equals(request.getMethod())) {
		response.sendError(response.SC_METHOD_NOT_ALLOWED);
		return;
	}

	if (revertSampleHistoryIdStr!=null) {
		try {
			revertSampleHistoryId=Integer.parseInt(revertSampleHistoryIdStr);
		} catch (NumberFormatException ex) {
			response.sendError(response.SC_BAD_REQUEST);
			return;
		}
	}

	if ("POST".equals(request.getMethod())) {
		if ("Cancel".equals(action)) {
			response.sendRedirect(request.getRequestURL().append("?sampleId=").append(sampleId).toString());
			return;
		} else if ("Submit".equals(action)) {
 			pageHelper.retrieveSingleSample(sampleId);
			pageHelper.revertToPreviousVersion(
					pageHelper.getFullSampleInfo(sampleId).mostRecentHistoryId,
					revertSampleHistoryId, 
					authController.getUserId(), request.getRemoteAddr(), 
					request.getParameter("comments"));
			response.sendRedirect(request.getRequestURL().append("?sampleId=").append(sampleId).toString());
			return;
		}
	}

	FullSampleInfo fullSampleInfo = pageHelper.getFullSampleInfo(sampleId);
	List list=fullSampleInfo.history;
	int mostRecentHistoryId=fullSampleInfo.mostRecentHistoryId;
	%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Reciprocal Net - <%=getServletInfo() %></title>
    <link href="../recipnet.css" rel="stylesheet" type="text/css" />
	</head>
	<body>
	<jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
	</jsp:include>
	<br />
	<center><A href="../showsample.jsp?sampleId=<%=sampleId%>">Display Sample</A> </center> <br />
	<center><A href="sample.jsp?sampleId=<%=sampleId%>">Edit Sample</A> </center> <br />
	<table>
	<tr>
		<th class="twoColumnLeft">Lab:</th>
		<td class="twoColumnRight"><%= HtmlHelper.nullToBlank(pageHelper.getLabInfo(fullSampleInfo.labId).name) %></td>
		<th class="twoColumnLeft">Provider:</th>
		<td class="twoColumnRight"><%= HtmlHelper.nullToBlank(pageHelper.getProviderInfo(fullSampleInfo.providerId).name) %></td>
	</tr>
	<tr>
		<th class="twoColumnLeft">Sample number:</th>
		<td class="twoColumnRight"><%= HtmlHelper.nullToBlank(fullSampleInfo.localLabId) %></td>
		<th class="twoColumnLeft">Status:</th>
		<td class="twoColumnRight"><%= HtmlHelper.statusStr(fullSampleInfo.mostRecentStatus) %></td>
	</tr>
	</table>
	<br /><br />

	<table border="1">
	<tr>
		<th>Date</th>
		<th>User</th>
		<th>Action</th>
		<th>New status</th>
		<th>Comments</th>
		<th>&nbsp;</th>
		<th>&nbsp;</th>
	</tr>	
	<%
	Iterator iterator=list.iterator();
	int i=0;
	while (iterator.hasNext()) {
		i++;
		SampleHistoryInfo sampleHistoryInfo=(SampleHistoryInfo) iterator.next();
		if (fullSampleInfo.mostRecentHistoryId == sampleHistoryInfo.id) {
  			%>
			<tr class="sampleHistoryBarRecent">
		<%
		} else if (revertSampleHistoryIdStr==null) {
		%>
			<tr class="rowColor<%=(i%2==0)?"true":"false"%>">
		<%
		} else if (revertSampleHistoryId == sampleHistoryInfo.id) {
		%>
			<tr class="rowColor<%=(i%2==0)?"true":"false"%>">
			<%
		} 
		if (revertSampleHistoryIdStr==null || revertSampleHistoryId == sampleHistoryInfo.id ||
				fullSampleInfo.mostRecentHistoryId == sampleHistoryInfo.id) {
			%>
				<td><%= dateFormat.format(sampleHistoryInfo.date)%></td>
				<td><%= HtmlHelper.nullToBlank(pageHelper.getUserInfo(sampleHistoryInfo.userId).fullName) %>&nbsp;</td>
				<td><%= HtmlHelper.actionStr(sampleHistoryInfo.action) %></td>
				<td><%= HtmlHelper.statusStr(sampleHistoryInfo.newStatus) %></td>
				<td><%= HtmlHelper.nullToBlank(sampleHistoryInfo.comments) %>&nbsp;</td>
				<td>
				<%
				if (fullSampleInfo.mostRecentHistoryId == sampleHistoryInfo.id) {
					%>
					<a href="sample.jsp?sampleId=<%=sampleId%>">View</a>
					</td><td>Most recent version
					<%
				} else {
				%>
					<a href="sample.jsp?sampleId=<%=sampleId%>&sampleHistoryId=<%=sampleHistoryInfo.id%>">View</a>
					</td><td>
				<%
					if (revertSampleHistoryIdStr==null) {
				%>
						<a href="samplehistory.jsp?sampleId=<%=sampleId%>&revertSampleHistoryId=<%=sampleHistoryInfo.id %>">
						Revert to this version
						</a>
				<%
					} else {
						out.println("Revert to version");
					}
				}
				%>
				</td>
				</tr>
			<%				
		} 
	} // for
	%>	
	</table>
	<br />
	<%
	if (revertSampleHistoryIdStr!=null) {
	%>
		<form method="POST">
		Comments:
		<input name="comments" type="text" size="120" /> <br />
		<input name="sampleId" type="hidden" value="<%=sampleId%>" />
		<input name="revertSampleHistoryId" type="hidden" value="<%=revertSampleHistoryId%>" />
		<center>
		<input name="action" type="submit" value="Submit" />&nbsp;&nbsp;&nbsp;&nbsp;
		<input name="action" type="submit" value="Cancel" />
		</center>
		</form>
	<%
	}
	%>
	
	<jsp:include page="/footer.jsp" />
	</body>
</html>
