<%--
  -- Reciprocal Net project
  -- stall.jsp
  --
  -- 26-Jul-2002: eisiorho wrote first draft
  -- 13-Sep-2002: jobollin fixed line delimiters (Task 433)
  --%>
<%@ page session="true" isThreadSafe="true"
        info="Stall Sample"
        import="org.recipnet.site.wrapper.HtmlHelper"
        import="org.recipnet.site.container.SampleInfo"
        import="org.recipnet.site.container.SampleHistoryInfo" %>
<%@ include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>
<%
    if ( !authController.checkUserAuthenticationStatus() ) {
        request.setAttribute("reason",
                AuthenticationController.AUTHENTICATION_REQUIRED);
%>
<jsp:forward page="/login.jsp" />
<%
    }

    int sampleId = SampleInfo.INVALID_SAMPLE_ID;
    String sampleIdStr = request.getParameter("sampleId");
    if (sampleIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleId = Integer.parseInt(sampleIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
        if ( !authController.canEditSample(sampleId) ) {
            request.setAttribute("reason",
                    AuthenticationController.INSUFFICIENT_ACCESS);
%>
<jsp:forward page="/login.jsp" />
<%
        }
    }

    /*
     * If control reaches here then the user is authorized to edit the
     * sample specified in his request.
     */

    int sampleHistoryId = SampleHistoryInfo.INVALID_SAMPLE_HISTORY_ID;
    String sampleHistoryIdStr = request.getParameter("sampleHistoryId");
    if (sampleHistoryIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleHistoryId = Integer.parseInt(sampleHistoryIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
    }
    pageHelper.retrieveSingleSample(sampleId, sampleHistoryId);
    boolean posted = false;
    String method = ((HttpServletRequest) request).getMethod();
    if ("POST".equals(method)) {
        posted = true;
        
        pageHelper.stallSample(sampleId, sampleHistoryId,
                               authController.getUserId(),
                               request.getRemoteAddr(),
                               HtmlHelper.nullToBlank(request.getParameter("comments")) );

        ((HttpServletResponse) response).sendRedirect("sample.jsp?sampleId=" + pageHelper.getSampleId());
                               
    } else if ( ! "GET".equals(method) ) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_METHOD_NOT_ALLOWED );
          return;
    }

    /*
     * If control reaches here then we have either a POST request with a
     * validation error or a GET request. Can go on and receive info to
     * display.
     */
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
  <link rel="stylesheet"
        href="../recipnet.css"
        type="text/css">
    <title><%= getServletInfo() %></title>
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
<%  if (posted) { %>
    <p class="errorMessage">Validation Error -- please check your entries and
      resubmit</p>
<%  } %>
    <p class="pageInstructions">
      Enter the comments on why the stalling of this chemical is necessary
      on the form below and click the &quot;Submit&quot; button to record it.
    </p>
    <center>
    <form method="POST">
      <input type="hidden" name="sampleId" value="<%=sampleId%>">
      <table>
        <tr>
          <th>Comments on why this sample needs to be stalled. (Optional)</th>
        </tr>
        <tr>
          <td align="left">
            <i>
              When you stall a sample, you are stating that for one reason or another, you are unable<br />
              to complete the analysis of sample <%= pageHelper.getSampleLocalLabId() %> at the moment. By stalling this sample, it will <br />
              be unable to be seen when searching for Solution pending structures.
            </i>
          </td>
        </tr>
        <tr>
          <td>&nbsp;</td>
        </tr>
        <tr>
          <td>
            <textarea name="comments" id="comments" rows="15"
                      cols="60" wrap="hard"></textarea>
          </td>
        </tr>
        <tr>
          <td>&nbsp;</td>
        </tr>
        <tr>
          <td>
            <input type="submit" value="Submit">
            <input type="reset" value="Reset">
          </td>
        </tr>
      </table>
    </form>
    </center>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
