<%--
  -- Reciprocal Net project
  -- submit.jsp
  --
  -- 26-Jul-2002: eisiorho wrote first draft
  -- 06-Aug-2002: eisiorho fixed bugs #248, #259
  -- 07-Aug-2002: eisiorho fixed bug #289
  -- 09-Aug-2002: eisiorho fixed bug #326
  -- 29-Aug-2002: leqian added localtracking support
  -- 13-Sep-2002: jobollin fixed line delimiters (Task 433)
  -- 25-Oct-2002: adharurk replaced the call to the function
  --              getAllProviderInfo() with one to getAllActiveProviderInfo()
  -- 12-Nov-2002: eisiorho fixed bug #597
  --%>
<%@ page session="true" isThreadSafe="true"
        info="Submit New Sample"
        import="org.recipnet.site.wrapper.HtmlHelper"
        import="org.recipnet.site.container.ProviderInfo"
        import="org.recipnet.site.container.SampleDataInfo"
        import="org.recipnet.site.container.LocalTrackingConfig"
        import="java.util.List"
        import="java.util.Iterator" %>
<%@ include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>
<%
    if ( !authController.checkUserAuthenticationStatus() ) {
        request.setAttribute("reason", authController.AUTHENTICATION_REQUIRED);
%>
        <jsp:forward page="/login.jsp" />
<%
    }else if ( !authController.canSubmitSamples() ) {
       request.setAttribute("reason", authController.INSUFFICIENT_ACCESS);
%>
        <jsp:forward page="/login.jsp" />
<%
    }
    /*
     * If control reaches here then the user is authorized to submit the
     * sample specified in his request.
     */
	pageHelper.retrieveLocalTrackingConfig(authController.getLabId());

    List activeProviders = pageHelper.getAllActiveProviderInfo(
            authController.getLabId());
    int m = 0;// Used for <select provider_Id>
    Iterator i;
    ProviderInfo provider;
    boolean posted = false;
    boolean isProvider = false;
    boolean filledLocalLabId = true;
    String localLabId = null;
    String method = ((HttpServletRequest) request).getMethod();
    if ("POST".equals(method)) {
        posted = true;

        // This checks to see if the User wishes to allow Reciprocal Net to
        // assign the Sample Number or wishes to assign the Sample Number
	// themselves.

        localLabId = request.getParameter("localLabId");
        if (request.getParameter("Sample_Number") == null) {
           ((HttpServletResponse) response).sendError(
	        HttpServletResponse.SC_BAD_REQUEST);
        }
        if ("0".equals(request.getParameter("Sample_Number"))
	        && HtmlHelper.nullToBlank(localLabId).equals("")) {
            filledLocalLabId = false;
            // Causes the program to drop out of the if statement and
	    // redisplay submit.jsp
        }else if ("1".equals(request.getParameter("Sample_Number"))) {
            localLabId = null;
        }

        if (filledLocalLabId) {
            try {
               i = activeProviders.iterator();
               while (i.hasNext()) {
                  provider = (ProviderInfo) i.next();
                  if (provider.id == HtmlHelper.validateRequiredInt(
                          0, SampleDataInfo.INVALID_INT_VALUE,
	                  request.getParameter("providerId"))){
                      isProvider = true;
                  }
               }
	if (isProvider){
	    String fieldValue;
	    int fieldType;
            while (pageHelper.moveNextLocalTrackingField(
	            LocalTrackingConfig.VISIBLE_ON_SUBMIT)) {
	        if (null==(fieldValue = request.getParameter("localTracking"
                        + (fieldType
	                =  pageHelper.getCurrentLocalTrackingFieldTextType())))
	                || fieldValue.trim().equals(""))
	            continue;
	            pageHelper.modifyLtaDuringNextAction(fieldType, fieldValue);
	        }
	    pageHelper.submitNewSample(authController.getUserId(),
            request.getRemoteAddr(),
            authController.getLabId(),
            HtmlHelper.validateRequiredInt(0,
	            SampleDataInfo.INVALID_INT_VALUE, request.getParameter(
	            "providerId")),
            localLabId,
            HtmlHelper.nullToBlank(request.getParameter("sampleProviderName")),
            HtmlHelper.nullToBlank(request.getParameter("anticipatedFormula")),
            HtmlHelper.nullToBlank(request.getParameter("comments")));
            ((HttpServletResponse) response).sendRedirect(
	            "sample.jsp?sampleId=" + pageHelper.getSampleId());
	} else {
	    ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        }

        } catch (NumberFormatException nfe) {
      // If there is a Format Exception, just drop out and let the other values
      // besides provider_Id be the values previously posted.
        }
        }
    } else if ( ! "GET".equals(method) ) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_METHOD_NOT_ALLOWED );
        return;
    }


    /*
     * If control reaches here then we have either a POST request with a
     * validation error or a GET request.
     */
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
  <link rel="stylesheet"
        href="../recipnet.css"
        type="text/css">
    <title>Reciprocal Net - <%= getServletInfo() %></title>
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
    <br />
<%  if (posted) { %>
    <p class="errorMessage">Validation Error -- please check your entries and
      resubmit</p>
<%  } %>
    <p class="pageInstructions">
      Enter the basic crystal data on the form below and click the
      &quot;Submit&quot; button to record it.
    </p>
    <form method="POST">
      <table cellpadding="10" class="formTable">
        <tr>
          <th align="left">Originating Lab:</th>
          <td>
           &nbsp;&nbsp;&nbsp;
           <b><%= authController.getLabName() %></b>
          </td>
        </tr>
        <tr>
          <th align="left">Please select a Provider group:</th>
          <td>
           &nbsp;&nbsp;&nbsp;
            <select name="providerId" id="providerId"> <%
             i = activeProviders.iterator();
             while (i.hasNext()) {
                 provider = (ProviderInfo) i.next();
                 if (m != 0){ %>
                     <option value="<%= provider.id %>">
                          <%= provider.name %></option> <% 
                 } else {
                     m = 1; %>
                     <option selected="true" value="<%= provider.id %>">
                          <%= provider.name %></option><%
                 }
             } %>
            </select>
          </td>
        </tr>
        <tr>
          <th align="left">Anticipated Empirical Formula (Optional)</th>
          <td>
           &nbsp;&nbsp;&nbsp;
            <input type="text" name="anticipatedFormula" id="anticipatedFormula"
                   size="32" maxlength="128"
                   value="<%= posted ? HtmlHelper.nullToBlank(
                           request.getParameter("anticipatedFormula")) : "" %>">
          </td>
        </tr>
        <tr>
          <th align="left">Contact Within Provider's Lab (Optional)</th>
          <td colspan="2">
           &nbsp;&nbsp;&nbsp;
            <input type="text" name="sampleProviderName" id="sampleProviderName"
                   size="52" maxlength="128"
                   value="<%= posted ? HtmlHelper.nullToBlank(
                         request.getParameter("sampleProviderName")) : "" %>" />
          </td>
        </tr>
        <tr>
          <td colspan="2">&nbsp;</td>
        </tr>
        <tr>
          <th align="center" colspan="2">Unique Sample Number</th>
        </tr>
        <tr>
          <td colspan="2" align="center">You can decide to identify your own
            Unique Sample Number, or let Reciprocal Net assign one for you.
          </td>
        </tr>
        <tr>
          <td colspan="2">&nbsp;</td>
        </tr>
        <tr>
          <td align="left" colspan="2">
            <p align="left">
             <input type="radio" name="Sample_Number" id="Sample_Number"
                   value="0" CHECKED> <b>My Choice</b> &nbsp;&nbsp;&nbsp;&nbsp;
             <input type="text" name="localLabId" id="localLabId" size="32"
                   maxlength="32" value="<%= posted ?
                           HtmlHelper.nullToBlank(
                                   request.getParameter("localLabId")): "" %>">
                    &nbsp;<br />
             <blockquote>
             <font class = 'comment'> The number must be unique within the lab
               and it should be up to 32 characters long including both,
               numbers and letters </font>
             </blockquote>
             <input type="radio" name="Sample_Number" id="Sample_Number"
                   value="1"> <b>Reciprocal Net Assigns Sample Number</b><br />
            </p>
          </td>
        </tr>
        <tr>
          <td colspan="2">&nbsp;</td>
        </tr>
<%
    while (pageHelper.moveNextLocalTrackingField(
                   LocalTrackingConfig.VISIBLE_ON_SUBMIT)) {
%>
		<tr>
		  <th>
		    <%=pageHelper.getCurrentLocalTrackingFieldName()%>:
		  </th>
		  <td>
		    <input type="text" size="64" name="localTracking<%=
                   pageHelper.getCurrentLocalTrackingFieldTextType()%>"
		           value="<%=posted?HtmlHelper.nullToBlank(
		               request.getParameter("localTracking" +
                       pageHelper.getCurrentLocalTrackingFieldTextType())):""%>">
		  </td>
		</tr>
<%	} %>
        <tr>
          <th align="center" colspan="2">Comments (Optional)</th>
        </tr>
        <tr>
          <td colspan="2"><center>
             <textarea name="comments" id="comments" rows="20" cols="80"
                       wrap="hard"><%= HtmlHelper.nullToBlank(
                       request.getParameter("comments")) %></textarea></center>
          </td>
        </tr>
        <tr>
          <td align="center" colspan="2">
            <input type="submit" value="Submit">&nbsp;
            <input type="reset" value="Reset">
          </td>
        </tr>
      </table>
    </form>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
