<%--
  -- Reciprocal Net project
  -- withdraw.jsp
  --
  -- 26-Jul-2002: eisiorho wrote first draft
  -- 13-Sep-2002: jobollin fixed line delimiters (Task 433)
  --%>
<%@ page session="true" isThreadSafe="true"
        info="Withdraw Sample"
        import="org.recipnet.site.wrapper.HtmlHelper"
        import="org.recipnet.site.container.SampleHistoryInfo"
        import="org.recipnet.site.container.SampleDataInfo"
        import="org.recipnet.site.container.LabInfo"
        import="org.recipnet.site.container.SampleInfo" %>
<%@ include file="/WEB-INF/common.inc" %>
<%-- authController, pageHelper, and replController now available --%>
<%
    if ( !authController.checkUserAuthenticationStatus() ) {
        request.setAttribute("reason",
                AuthenticationController.AUTHENTICATION_REQUIRED);
%>
<jsp:forward page="/login.jsp" />
<%
    }

    int sampleId = SampleInfo.INVALID_SAMPLE_ID;
    String sampleIdStr = request.getParameter("sampleId");
    if (sampleIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleId = Integer.parseInt(sampleIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
        if ( !authController.canEditSample(sampleId) ) {
            request.setAttribute("reason",
                    AuthenticationController.INSUFFICIENT_ACCESS);
%>
<jsp:forward page="/login.jsp" />
<%
        }
    }

    /*
     * If control reaches here then the user is authorized to edit the
     * sample specified in his request.
     */

    int sampleHistoryId = SampleHistoryInfo.INVALID_SAMPLE_HISTORY_ID;
    String sampleHistoryIdStr = request.getParameter("sampleHistoryId");
    if (sampleHistoryIdStr == null) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_BAD_REQUEST);
        return;
    } else {
        try {
            sampleHistoryId = Integer.parseInt(sampleHistoryIdStr);
        } catch (NumberFormatException nfe) {
            ((HttpServletResponse) response).sendError(
                    HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
    }

    pageHelper.retrieveSingleSample(sampleId, sampleHistoryId);

    boolean posted = false;
    String method = ((HttpServletRequest) request).getMethod();
    if ("POST".equals(method)) {
        posted = true;

        pageHelper.withdrawSample(sampleId, sampleHistoryId,
                               authController.getUserId(),
                               request.getRemoteAddr(),
                               HtmlHelper.validateOptionalInt(-2, 2147483647, request.getParameter("supersampleId")),
                               HtmlHelper.nullToBlank(request.getParameter("Super_seded")),
                               HtmlHelper.nullToBlank(request.getParameter("Super_sedes")),
                               HtmlHelper.nullToBlank(request.getParameter("comments")) );

            ((HttpServletResponse) response).sendRedirect("sample.jsp?sampleId=" + pageHelper.getSampleId());

    } else if ( ! "GET".equals(method) ) {
        ((HttpServletResponse) response).sendError(
                HttpServletResponse.SC_METHOD_NOT_ALLOWED );
        return;
    }

    /*
     * If control reaches here then we have either a POST request with a
     * validation error or a GET request. Can go on and receive info to
     * display.
     */
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
  <link rel="stylesheet"
        href="../recipnet.css"
        type="text/css">
    <title>Reciprocal Net - <%= getServletInfo() %></title>
  </head>
  <body>
    <jsp:include page="/header.jsp">
        <jsp:param name="pageTitle" value="<%=getServletInfo() %>" />
    </jsp:include>
<%  if (posted) { %>
    <p class="errorMessage">Validation Error -- please check your entries and
      resubmit</p>
<%  } %>
    <p class="pageInstructions">
      Enter the reasons for withdrawing the crystal sample from the Reciprocal Net
      on the form below and click the &quot;Submit&quot; button to record it.
    </p>
    <center>
      <form method="POST">
        <input type="hidden" name="sampleId" value="<%=sampleId%>">
        <table cellpadding="10" class="formTable">
          <tr>
            <th>Comments (Optional):<br />&nbsp;<br />
              <i>Please comment on the reason why this particular sample<br />
                 is being removed from the Reciprocal Net database.
              </i>
            </th>
            <td align="left">
              <textarea name="comments" id="comments" rows="9"
                        cols="39" wrap="hard"></textarea>
            </td>
          </tr>
          <tr>
            <th>Superseding Sample ID:<br />&nbsp;<br />
              <i>
                If another (existing) sample is replacing this one, please enter the <br />
                other Sample Id here.
              </i>
            </th>
            <td align="center">
              <input type="text" name="supersampleId" id="supersampleId"
                     size="32" maxlength="32">
            </td>
          </tr>
          <tr>
            <th>Superseding Comments (Optional):<br />&nbsp;<br />
              <i>
                These are the comments that will correspond with the sample given <br />
                in the Superseding Sample ID: field. This field is only useful if <br />
                the Superseding Sample ID: field is completed.
              </i>
            </th>
            <td align="center">
              <textarea name="Super_sedes" id="Super_sedes" rows="9"
                        cols="39" wrap="hard"></textarea>
            </td>
          </tr>
          <tr>
            <th>Superseded Comments (Optional):<br />&nbsp;<br />
              <i>
                These are the comments that corresponded with the sample being withdrawn <br />
                from the Reciprocal Net database. This field is only useful if the <br />
                Superseding Sample ID: field is completed.
              </i>
            </th>
            <td align="center">
              <textarea name="Super_seded" id="Super_seded" rows="9"
                        cols="39" wrap="hard"></textarea>
            </td>
          </tr>
        </table>
        <input type="submit" value="Submit">
        <input type="reset" value="Reset">
      </form>
    </center>
    <jsp:include page="/footer.jsp" />
  </body>
</html>
